	EVEN			; Parit pour les pointeurs

; *** TABLE DES VARIABLES ***

var_table:

	ds.b	256

; *** LISTE DES BOITES DE DIALOGUE ***

BoxTable:
	IFD ti89
	dc.b	6,0,XSCREEN-6,48					; Saisie d'un nom HAUT
	dc.b	0,48,XSCREEN,YSCREEN-48				; Saisie d'un nom BAS
	ENDIF
	IFND ti89	
	dc.b	6,0,XSCREEN-6,49					; Saisie d'un nom HAUT
	dc.b	2,58,XSCREEN-4,YSCREEN-66			; Saisie d'un nom BAS
	ENDIF
	dc.b	0,0,XSCREEN,52					; Dialogue classique HAUT
	dc.b	0,YSCREEN-52,XSCREEN,52				; Dialogue classique BAS
	dc.b	0,0,XSCREEN,YSCREEN				; Plein cran

; *** LISTE DES FONTES ***

FontTable:		; Table des fontes
small:
	dc.b	0,0		; Taille X,Y en pixels
	dc.l	0		; Pointeur sur la Fonte
	dc.l	0		; Pointeur sur la table de correction
medium:
	dc.b	0,0		; Taille X,Y en pixels
	dc.l	0		; Pointeur sur la Fonte
	dc.l	0		; Pointeur sur la table de correction
large:
	dc.b	0,0		; Taille X,Y en pixels
	dc.l	0		; Pointeur sur la Fonte
	dc.l	0		; Pointeur sur la table de correction

; *** Donnes permanentes utilises pour la gestion des dialogues ***

current_font:
	dc.l	0		; Pointeur sur le TypeFonte
	dc.w	0		; Valeur  ajouter pour trouver le caractre
current_screen:
	ds.b	4		; X , Y , Taille_X , Taille_Y
current_box:
	ds.b	4		; X , Y , Taille_X , Taille_Y
Old_CurX:
	dc.w	0
Old_CurY:
	dc.w	0
P_String:
	dc.l	0
get_namePos:
	dc.b	0
get_nameCharP:
	dc.b	0
style:
	dc.b	0
couleur:
	dc.b	0
delay:
	dc.b	0
put_n_char:
	dc.b	0
small_font_active:
	dc.b	0
current_name:
	ds.b	36		; EQU 30 caractres...

; *** LISTE DES PERSONNAGES ***

Crono_p:		dc.b	"Crono",EndDialog
Lucca_p:		dc.b	"Lucca",EndDialog
Marle_p:		dc.b	"Marle",EndDialog
Frog_p:		dc.b	"Frog ",EndDialog
Robo_p:		dc.b	"Robo ",EndDialog
Ayla_p:		dc.b	"Ayla ",EndDialog
Magus_p:		dc.b	"Magus",EndDialog

; *** LISTE DES IMAGES ***

Crono_i:		dc.b		6			; Taille X*8
			dc.b		47			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\Graph\Cr.gfx"	; Image (ligne par ligne)
Lucca_i:		dc.b		6			; Taille X*8
			dc.b		47			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\Graph\Lu.gfx"	; Image (ligne par ligne)
Marle_i:		dc.b		6			; Taille X*8
			dc.b		47			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\Graph\Ma.gfx"	; Image (ligne par ligne)
Frog_i:			dc.b		6			; Taille X*8
			dc.b		47			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\Graph\Fr.gfx"	; Image (ligne par ligne)
Robo_i:		dc.b		6			; Taille X*8
			dc.b		47			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\Graph\Ro.gfx"	; Image (ligne par ligne)
Ayla_i:			dc.b		6			; Taille X*8
			dc.b		47			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\Graph\Ay.gfx"	; Image (ligne par ligne)
Magus_i:		dc.b		6			; Taille X*8
			dc.b		47			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\Graph\Mg.gfx"	; Image (ligne par ligne)
Buffer_Pic:		dc.b		0			; Taille X*8
			dc.b		0			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
	ds.b		10*80				; Suffisant pour un buffer d'image ? (80*80 pixels)

; *** Images additionelles ***

curseur_picon:	dc.b		2			; Taille X*8
			dc.b		7			; Taille Y-1
			dc.b		0			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\graph\Cursor.gfx"	; Image (ligne par ligne)
curseur_picoff:	dc.b		2			; Taille X*8
			dc.b		7			; Taille Y-1
			dc.b		1			; 0 = Masque par plan & 1 = Affichage en force
			ds.b		32		; BackCursor Buffer
char_pointer:		dc.b		1			; Taille X*8
			dc.b		5			; Taille Y-1
			dc.b		0			; 0 = Masque par plan & 1 = Affichage en force
	include		"Chroninc\graph\Pointer.gfx"	; Image (ligne par ligne)
	include		"Chroninc\Graph\Box.gfx"

; *** TABLE DE CORRECTION DES FONTES ***

correction_nulle:
	dc.b	0			; Correction : 0 = N & 1 = Y
correction_small:
	dc.b	1
	dc.b	3,3,3,3,2,2,2,1,3,2
	dc.b	2,2,2,1,2,0,0,0,2,2
	dc.b	1,1,0,0,0,0,2,1,1,1
	dc.b	0,-2,-2,0,2,2,0,1,-2,-1
	dc.b	-1,2,0,-1,0,-2,0,0,0,0
	dc.b	0,0,0,0,0,0,0,-2,-1,0
	dc.b	0,0,0,2,0,0,0,0,0,0
	dc.b	1,0,-2,0,1,0,2,1,0,0
	dc.b	1,0,0,0,0,0,2,0,0,0
	dc.b	-1,0,-1,0,0,-1,0,0,0,0
	dc.b	0,-1,0,0,-2,0,0,-1,2,0
	dc.b	0,0,0,0,-1,-1,0,0,2,0
	dc.b	0,1,0,-2,0,1,2,0