demos::t3:
	move.l	Screen_1(a6),d0
	jsr	genlib::set_dscreen_function
	jsr	genlib::set_dscreen_int

	clr.w	genlib::sprite_scr_x
	clr.w	genlib::sprite_scr_y

	lea	Jenny_shk(Pc),a0
	jsr	shrnklib::OpenArchive
	move.w	d0,d4

	moveq	#10,d5
\loop1		jsr	genlib::cls
		bsr	Wait
		dbf	d5,\loop1
	
	; X 
	ifnd	ti89
	move.w	#70,d5
	endif
	ifd	ti89
	move.w	#50,d5
	endif

	; Affiche
	moveq	#0,d7
	moveq	#20,d6
\loop2
		; Extract
		move.w	d4,d0	; Handle
		move.w	d7,d1	; Index
		move.l	genlib::window,a0	; Where ?
		jsr	shrnklib::Extract
		move.l	a0,d0
		beq.s	\quit
\loop3			tst.l	genlib::timer
			beq.s	\loop3
			jsr	genlib::cls
			move.w	d5,d0
			moveq	#10,d1
			jsr	genlib::put_big_sprite ; A0 n'a pas ete modifie
			bsr	Wait
			subq.w	#1,d5		; On dec x
			dbf	d6,\loop3
		moveq	#5,d6
		addq.w	#1,d7		; Image suivante
		cmp.w	#5,d7
		bne.s	\loop2

	; Affiche le logo (Pas beau :()
	ifnd	ti89
	move.w	#170,d0
	endif
	ifd	ti89
	move.w	#160-8*4,d0
	endif
	moveq	#35,d1
	move.l	Current_dscreen(a6),a1
	lea	Time_str(Pc),a0
	jsr	genlib::put_large_string
	moveq	#50,d1
	lea	To_str(Pc),a0
	jsr	genlib::put_large_string
	moveq	#65,d1
	lea	Team_str(Pc),a0
	jsr	genlib::put_large_string
	jsr	genlib::copy_window

	ifnd	ti89
	move.w	#167,d0
	endif
	ifd	ti89
	move.w	#160-4*8-2,d0
	endif
	moveq	#90,d1
	lea	Present_str(Pc),a0
	jsr	genlib::put_small_string

	jsr	genlib::wait_a_key

\quit:
	move.w	d4,d0
	jmp	shrnklib::CloseArchive

Wait:
	move.w	Select_s(a6),d1
	move.l	Screen_1(a6,d1.w),d0
	move.l	d0,Current_dscreen(a6)
	jsr	genlib::set_dscreen_int
	eor.w	#4,d1
	move.w	d1,Select_s(a6)
	move.l	Screen_1(a6,d1.w),d0
	jsr	genlib::set_dscreen_function
	
\wait:		cmp.l	#2,genlib::timer
		bls.s	\wait
	clr.l	genlib::timer
	rts


Jenny_shk:
	incbin "demos\jenny.shk"

Time_str:	dc.b "TIME",0
To_str:		dc.b " TO ",0
Team_str:	dc.b "TEAM",0
Present_str:	dc.b "presents",0

	EVEN
