; Module sprites
; Sous-module :
;	Gestion des persos du joueur sur la carte.


init_follow:
	move.w	Startx(a6),d0		; Lecture coordonnes
	move.w	Starty(a6),d1		; Lecture coordonnes

	move.w	d0,X(a5)
	move.w	d1,Y(a5)

	; Clear tampon
	clr.w	Tampon_ptr(a5)
	lea	Tampon(a5),a0
	moveq	#8-1,d2
\loop		move.w	d0,(a0)+
		move.w	d1,(a0)+
		clr.w	(a0)+
		dbf	d2,\loop

	suba.l	a4,a4
;	moveq	#0,d4
	bsr	player::init

	rts

exec_follow:
	move.l	(a3)+,a5

	move.l	Follow_adr(a6),a4

	; Validation du deplacement
	moveq	#ANI_NORMAL,d5
	cmp.b	Ani(a4),d5
	beq.s	\done

		; Le sauvegarde dans la position courante
		move.w	Tampon_ptr(a5),d2

		lea	Tampon(a5),a0
		adda.w	d2,a0
		move.w	X(a4),(a0)+
		move.w	Y(a4),(a0)+
		move.b	Sens(a4),(a0)+
		move.b	Ani(a4),(a0)+

		addq.w	#2+2+1+1,d2
		cmp.w	#7*(2+2+1+1),d2
		bls.s	\ok
			clr.w	d2
\ok:		move.w	d2,Tampon_ptr(a5)

		; Lecture 2nd perso
		lea	Tampon(a5),a0
		adda.w	d2,a0
		move.w	(a0)+,d0
		move.w	d0,X(a5)	; X
		move.w	(a0)+,d1
		move.w	d1,Y(a5)	; Y
		move.b	(a0)+,Sens(a5)	; Sens
		move.b	(a0)+,d5	; D5 = new animation
		bsr	player::check_pos
		beq.s	\done
			move.b	d1,H(a5)		; Set Height
\done:	
	bsr	player::animation	; Set animation
	move.l	a5,Follow_adr(a6)

	move.l	(a3)+,a0
	jmp	(a0)
