; Module sprite
; Sous-module : Sprite contenant un perso immobile

; On passe en argument :
;	d3.w = No du personnage a initialiser.
;	d4.w = Level du perso ou '0' s'il ne peut pas se battre
;	A4.l -> Dialog struct ou NULL

exec_immobile:
	; On lit l'adresse des donnes
	move.l	(a3)+,a5

	; Le faire se deplacer et mettre a jour l'animation et le sens
	
	; Test validite du deplacement
	
	; Test collision Personnages principals
	; Non, donc on quitte
		; Sinon :
		; Si P+F+LEVEL(a5) == 0 && Action key = Off => Retour de force et quitter
		; Si Dialog_adr.l != 0 => Faire le dialogue
		; Si P+F+LEVEL(a5) != 0 => Fight
immobile::collision:
	move.w	X(a5),d0
	move.w	Y(a5),d1
	; Test collision grande boite
	test_d6_collision d0,d1,24,24,d2,imm_no_collision
	move.l	key(a6),d2
	btst.l	#action_key,d2
	bne.s	\no_diag
	move.l	Diag_adr(a5),d2
	beq.s	\no_diag

		move.w	Sens(a5),-(a7)	; Sauve sens original
		move.l	d2,-(a7)		;  -> Dialogue
		move.l	a5,-(a7)		; Sauve pointeur 

		; Determine le sens pour la discussion
		move.w	X(a5),d0
		move.w	Y(a5),d1
		move.l	d6,d5
		swap	d5
		sub.w	d5,d0			; X-X_perso
		sub.w	d6,d1			; Y-Y_perso
		bsr	player::calc_sens
		move.b	d2,Sens(a5)

		bsr	print::print
		bsr	Wait_next_frame

		; Dialogue
		move.l	(a7)+,a5
		move.l	(a7)+,a0
		bsr	dialog::do
		move.w	(a7)+,Sens(a5)	; Remet le bon sens
\no_diag
	; test collision petite boite
	move.w	X(a5),d0
	move.w	Y(a5),d1
	test_d6_collision.s d0,d1,14,14,d2,imm_no_collision
		move.l	Main_adr(a6),a0
		move.w	X_old(a0),X(a0)
		move.w	Y_old(a0),Y(a0)
imm_no_collision:

	; Next module
	move.l	(a3)+,a0
	jmp	(a0)
	