; Module sprite
; Sous-module : Sprite contenant un perso qui suit un chemin pre-etabli
; Le chemin est determine par les TAGS : POSITION

; Initalisation:
;	d3.w = No du personnage a initialiser.
;	d4.w = Level du perso ou '0' s'il ne peut pas se battre
;	A4.l -> Dialog struct ou NULL


init_route:
	bsr	position::ref
	move.w	d2,P_action(a5)
	bsr	position::deref
	move.w	d0,Xd(a5)
	move.w	d1,Yd(a5)
	rts

exec_route:
	move.l	(a3)+,a5

	; Determine le sens de la direction
	move.w	X(a5),d0
	move.w	Y(a5),d1
	sub.w	Xd(a5),d0			; X-X_dest
	sub.w	Yd(a5),d1			; Y-Y_dest
	bsr	player::calc_sens
	move.b	d2,Sens(a5)

	bsr	player::move
	bsr	player::check_move

	; Test si on est arrive
	move.l	X(a5),d0
	cmp.l	Xd(a5),d0
	bne.s	\no
		move.w	P_action(a5),d2
		bsr	position::next
		move.w	d0,Xd(a5)
		move.w	d1,Yd(a5)
		move.w	d2,P_action(a5)
\no:

	bra	immobile::collision
