; 
;	Gestion du perso du joueur sur la carte.


init_main:
	move.w	Startx(a6),X(a5)		; Lecture coordonnes
	move.w	Starty(a6),Y(a5)		; Lecture coordonnes
	suba.l	a4,a4
	bra	player::init

exec_main:
	move.l	(a3)+,a5			; Lecture de l'adresse des donnes du sprite

	move.l	a5,Main_adr(a6)
	move.l	a5,Follow_adr(a6)

	move.l	key(a6),d4

	; Test course
	moveq	#4,d3		; Vitesse
	moveq	#ANI_WALK,d5	; Animation

	btst.l	#run_key,d4
	bne.s	\no_run
		moveq	#8,d3		; Vitesse
		moveq	#ANI_RUN,d5	; Animation
\no_run:

	; Deplacement
	move.w	X(a5),d0
	move.w	Y(a5),d1
	move.w	d0,X_old(a5)
	move.w	d1,Y_old(a5)

	st	d2		; D2 = true
	cmp.b	#1,Sens(a5)
	bhi.s	\y_then_x

		; D'abord X puis Y :) - Petite bidouille, qui fait un petit truc assez agreable
		btst.l	#left_key,d4
		bne.s	\no_left
			sub.w	d3,d0
			move.b	#2,Sens(a5)
			clr.b	d2
\no_left:
		btst.l	#right_key,d4
		bne.s	\no_right
			add.w	d3,d0
			move.b	#3,Sens(a5)
			clr.b	d2
\no_right:
		btst.l	#up_key,d4
		bne.s	\no_up
			sub.w	d3,d1
			clr.b	Sens(a5)
			clr.b	d2
\no_up:
		btst.l	#down_key,d4
		bne.s	\done_move
			add.w	d3,d1
			move.b	#1,Sens(a5)
			clr.b	d2
			bra.s	\done_move

\y_then_x:
	btst.l	#up_key,d4
	bne.s	\no_up2
		sub.w	d3,d1
		clr.b	Sens(a5)
		clr.b	d2
\no_up2:
	btst.l	#down_key,d4
	bne.s	\no_down2
		add.w	d3,d1
		move.b	#1,Sens(a5)
		clr.b	d2
\no_down2:
	btst.l	#left_key,d4
	bne.s	\no_left2
		sub.w	d3,d0
		move.b	#2,Sens(a5)
		clr.b	d2
\no_left2:
	btst.l	#right_key,d4
	bne.s	\no_right2
		add.w	d3,d0
		move.b	#3,Sens(a5)
		clr.b	d2
\no_right2:

\done_move:
	; Validation du deplacement
	tst.b	d2
	beq.s	\move_ok
		moveq	#ANI_NORMAL,d5
		bsr	player::animation

		; Modifier les follows  pour qu'il s'arrete et passe en mode normal !
		move.w	d0,d3
		move.w	d1,d4
		bra.s	\gestion_items

	; On s'est deplace.
\move_ok
	; Enregistre l'animation & valide le deplacement
	bsr	player::animation
	move.w	d0,d3
	move.w	d1,d4
	bsr	player::check_move
	
\gestion_items:

	; Bouton : basculement des persos
	move.l	key(a6),d0
	btst.l	#kf_key,d0
	bne.s	\no_next
		btst.l	#run_key,d0		; A cause d'un bug de lecture de touches
		beq.s	\no_next		; sur 92 :(
			bsr	member::next
			bra.s	\rien
\no_next:
	; Bouton de debuggage.
	btst.l	#kh_key,d0
	bne.s	\rien
;		lea	MainDialog(Pc),a0
;		bsr	dialog::do
		bsr	console::enter
\rien:

	; Cree d6 (Collision entre sprites)
	move.w	d3,d6
	swap	d6
	move.w	d4,d6

	; Gestions items
	move.l	Height_tab(a6),a4
	move.l	Items_list(a6),a2
	subq.w	#8,d3
	sub.w	#16,d4
	lsr.w	#4,d3
	lsr.w	#4,d4
	lsl.w	d7,d4
	add.w	d3,d4	; Determine l'offset
	adda.w	d4,a4	; a4 -> Case dans l'Height table

	bsr.s	item
	addq.l	#1,a4
	bsr.s	item
	adda.w	Map_x(a6),a4
	bsr.s	item
	subq.l	#1,a4
	bsr.s	item

	; Next module
	move.l	(a3)+,a0
	jmp	(a0)

item:
	moveq	#0,d0
	move.b	(a4),d0
	cmp.b	#16,d0
	bcs.s	Item_rien
		lsr.w	#3,d0	; Get no of items
		subq.w	#1,d0	; Skip the 5 firsts items
		lsl.w	#3,d0	; Get index of item
		lea	0(a2,d0.w),a1
		moveq	#0,d1
		move.b	(a1),d1
		cmp.b	#ITEM_MAP,d1
		bcc.s	Item_map
			add.w	d1,d1
			move.w	Item_code_table(Pc,d1.w),d1
			jmp	Item_code_table(Pc,d1.w)

Item_code_table:
	dc.w	Item_rien-Item_code_table	;0 Sprite
	dc.w	Item_coffre-Item_code_table	;1
	dc.w	Item_dialog-Item_code_table	;2
	dc.w	Item_story-Item_code_table	;3
	dc.w	Item_loc_story-Item_code_table	;4
	dc.w	Item_block_obj-Item_code_table	;5
	dc.w	Item_block_sto-Item_code_table	;6
	dc.w	Item_ladder-Item_code_table	;7
	dc.w	Item_fall-Item_code_table	;8
	dc.w	Item_rien-Item_code_table	;9 Position

; A5 -> *Sprite_main
; A4 -> *Height
; A2 -> *Item
Item_rien:
	rts

Item_map:	
	; Copie la carte temporairement dans Free_buffer
	lea	Free_buffer(a6),a0
	moveq	#6-1,d2
\cpy_loop:	move.b	(a1)+,(a0)+
		dbf	d2,\cpy_loop
	clr.b	(a0)
	; Determine x et y
	moveq	#0,d0
	move.b	(a1)+,d0
	lsl.w	#4,d0
	moveq	#0,d1
	move.b	(a1)+,d1
	lsl.w	#4,d1
	; Sauve la position iniale
	move.w	d0,Startx(a6)
	move.w	d1,Starty(a6)
	lea	Free_buffer(a6),a0			; Petits pb, je crois...
	move.b	#_RESTART_MODE,Game_mode(a6)
	addq.l	#4,a7
	bra	game::select_map

Item_coffre:
	; Lecture touche
	move.l	key(a6),d0
	btst.l	#action_key,d0
	bne.s	Item_rien
		; Add coffre
		move.w	4(a1),d0
		bsr	chest::is	; Test coffre deja ouvert...
		tst.b	d1
		beq.s	Item_rien
			bsr	chest::add	; On ne l'ouvrira plus celui la !
			; Modifie le graph
			move.l	a4,a0
			suba.l	Height_tab(a6),a0
			adda.l	Graph_adr(a6),a0
			addq.b	#1,(a0)
			; Add objet
			move.w	2(a1),d0
			bsr	object::add
			; Dialogue personnel ?
			move.w	6(a1),d1
			beq.s	\print
				lea	0(a2,d1.w),a0
				bra	dialog::do
\print:
			bsr	object::deref
			lea	F_cpy(Pc),a1
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			lea	Found_str(Pc),a0
			bra	dialog::message
Found_str:
	dc.b "Found "
F_cpy:	dc.l	0
	dc.l	0
	dc.w	0

Item_dialog:
	; Lecture touche
	move.l	key(a6),d0
	btst.l	#action_key,d0
	bne	Item_rien
		move.w	6(a1),d1
		lea	0(a2,d1.w),a0
		bra	dialog::do
	
Item_story:
	move.w	2(a1),d0
	bra	event::give

Item_loc_story:
	; Modifie la cellule pour eviter les appels sans fin autre qu'une erreur
	move.b	(a4),d2
	and.w	#%0000000011111100,d2
	and.b	#%0011,(a4)
	lsr.w	#2,d2
	; Calcul coordonnes
	move.l	a4,d0
	sub.l	Height_tab(a6),d0
	move.w	d0,d1
	lsr.w	d7,d1
	and.w	Mask_x(a6),d0
	lsl.w	#4,d0
	lsl.w	#4,d1

	move.w	6(a1),d3
	lea	0(a2,d3.w),a1 
	bra	event::local

Item_block_obj:
	move.w	2(a1),d0
	bsr	object::is
Item_block_clear:
	beq.s	\nothing
		; Modifie la hauteur
		and.b	#%11111100,(a4)
		; Modifie le graph
		move.l	a4,a0
		suba.l	Height_tab(a6),a0
		adda.l	Graph_adr(a6),a0
		clr.b	(a0)
\nothing:
	rts

Item_block_sto:
	move.w	2(a1),d0
	bsr	event::is
	bra.s	Item_block_clear

Item_ladder:

Item_fall:
