; ***********************************************************************
; *									*
; *		Definitions des donnes du module 'sprite'		*
; *									*
; ***********************************************************************

	NEW_DATA
	rs	Buffer_adr,4			; Adresse du debut du buffer de liens
	rs	Sprite_adr,4			; Adresse du debut des sprites a gerer
	rs	Sprite_end_adr,4		; Adresse de fin des sprites a gerer
	rs	Main_adr,4			; Adresse du perso principal
	rs	Follow_adr,4			; Adresse du personnage courant
	rs	Spr_print_adr,4			; Adresse du debut des sprites a afficher
	rs	Spr_print_end_adr,4		; Adresse de fin des sprites a afficher
	rs	Spr_level,2			; Niveau courant des types des sprites (Type 1,2,3 ?)

; Ajoute un sprite au tableau de sprites
; ADD_SPR	SPR_NAME,Map_type,Priority,Drawing,Player_flag,spr_size,init_offset
Spr_table_compteur	set	0
ADD_SPR		MACRO
	dc.b	\4,\5,\2,\3
	dc.w	\6		; Size
	dc.w	\7-Sprite_table	; Init
\1		set	Spr_table_compteur
Spr_table_compteur	set	Spr_table_compteur+1
		ENDM

; ADD_TYPE	TYPE_NAME,Type_exec
Type_table_compteur	set	0
ADD_TYPE	MACRO
	dc.w	\2-Type_table
\1			set	Type_table_compteur
Type_table_compteur	set	Type_table_compteur+2
		ENDM
; ADD_TYPE_VOID	TYPE_NAME
ADD_TYPE_VOID	MACRO
	dc.w	0
\1			set	Type_table_compteur
Type_table_compteur	set	Type_table_compteur+2
		ENDM

; CALL:  
;  test_collision x1,y1,mx1,my1,x2,y2,mx2,my2,label_if_no_collision
; x2 and y2 should be register and will be detroy.
; mx1 -> my2 : immediate value
; Destroy : x2 and y2
test_collision	MACRO
	sub.w	\1,\5
	bge.s	\@Ok
	neg.w	\5
\@Ok:	cmp.w	#((\3+\7)/2),\5
	bhi.\0	\9
	sub.w	\2,\6
	bge.s	\@Ok2
	neg.w	\6
\@Ok2:	cmp.w	#((\4+\8)/2),\6
	bhi.\0	\9
		ENDM
; CALL:
; test_d6_collision x, y, mx, my, ds, label_if_no_collision
; ds is a temporary register which will be destroy
; x and y must be registers / will be destroy
test_d6_collision	MACRO
	move.l	d6,\5
	swap	\5
	test_collision.\0 \5,d6,16,16,\1,\2,\3,\4,\6
			ENDM

SIZE_SPRITE_BUFFER	EQU	4000
MAX_SPRITE		EQU	100
SIZE_LINK_BUFFER	EQU	100*8
SIZE_UNPRINT_BUFFER	EQU	1000
