; Utilisation :	Create_NewFont	TypeFonte, Pointeur sur la Fonte, Pointeur sur la Correction, Taille X, Taille Y

Create_NewFont		MACRO
	lea		\1,a6
	move.b	\4,(a6)+
	move.b	\5,(a6)+
	move.l		\2,(a6)+
	lea		\3,a5
	move.l		a5,(a6)
	ENDM

; Utilisation :	Use_Font		TypeFonte

Use_Font			MACRO
	move.l		\1,a0
	lea		current_font,a1
	move.l		a0,(a1)+
	clr.w		d0
	move.b	(a0),d0			; D0 = Taille X de la fonte
	subq.b		#1,d0			; D0 = Taille X-1 de la fonte
	lsr.b		#3,d0			; D0 = Taille (X-1)/8 de la fonte
	addq.b		#1,d0			; D0 = Taille (X-1)/8+1 de la fonte
	clr.w		d1			; D1 = 0
	move.b	1(a0),d1		; D1 = Taille Y de la fonte
	mulu.b		d0,d1			; D0 * D1 = Somme  ajouter pour trouver le char
	move.w	d1,(a1)
	ENDM

; Utilisation :	Set_Cursor		X,Y

Set_Cursor			MACRO
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	\1,VAR_CurseurX(a0)
	move.b	\2,VAR_CurseurY(a0)
	move.l		(a7)+,a0
	ENDM

; Utilisation :	Get_Cursor		X,Y

Get_Cursor			MACRO
	move.l		a0,-(a7)
	lea		var_table,a0
	clr.w		\1
	clr.w		\2
	move.b	VAR_CurseurX(a0),\1
	move.b	VAR_CurseurY(a0),\2
	move.l		(a7)+,a0
	ENDM

; Utilisation :	Load_String		Chaine

Load_String			MACRO
	lea			\1,a0
	move.l			a0,P_String
	ENDM

; Utilisation :	bsr			Pos_CursorXY

Pos_CursorXY:
	move.l		ecran1,a0
	move.l		ecran2,a1
	Get_Cursor	d0,d1
	mulu.w		#Taille_ecran,d1	; Calcul des coordonnes Y = OK
						; L'utilisation du mulu est tolre (Enfin on va dire a...)
	move.w	d0,d7			; Calcul des coordonnes X/8
	and.b		#7,d7			; D7 = Reste de X/8
	lsr.w		#3,d0			; D0 = Quotient de X/8
	add		d1,d0			; Ajout des valeurs D1+D0
	add		d0,a0			; Premier cran positionn
	add		d0,a1			; Second cran positionn
	rts

; Utilisation :	StartDialog

StartDialog:
	lea		current_font,a2	; A2 = Pointeur sur TypeFonte
	move.l		(a2),a3			; A3 = TypeFonte
	lea		P_String,a5
	move.l		(a5),a5			; A5 = Pointeur sur Chaine
	bsr		Pos_CursorXY		; Dfinit la position ecran
\LOOP
	clr.w		d0
	move.l		a5,P_String
	move.b	(a5),d0			; D0 = Caractre courant
	cmp.b		#127,d0
	bhi		\TAGS_DETECTED	; Si D0 >127 alors TAGS
	cmp.b		#32,d0
	beq		\SPACE_DETECTED	; Si D0 = 32 alors SPACE
\SPACE_OK
	clr.w		d1
	move.b	delay,d1
	lsl.w		#8,d1
\LoopDelay
	divu		#5,d3			; Une manire d'attendre comme une autre ;)
	dbra.s		d1,\LoopDelay
	move.l		2(a3),a4		; A4 = Pointeur sur Fonte
	move.w	4(a2),d1		; D1 = Taille de la fonte
	mulu.w		d0,d1			; Caractre * Taille fonte
	add		d1,a4			; Fonte positionne

	movem.l	a0-a1,-(a7)		; Sauvegarde de la position des crans
	clr.w		d0
	move.b	1(a3),d0		; D0 = Taille Y de la fonte
	move.b	small_font_active,d1	; D1 = Correction de fonte
	addq.b		#1,d1
	sub.b		d1,d0			; D0 = Boucle Y correcte
\Small_Font_Correction
	clr.w		d4
	move.b	(a3),d4			; D4 = Taille X de la fonte
	subq.b		#1,d4			; D4 = Taille X-1 de la fonte
	lsr.b		#3,d4			; D4 = Taille (X-1)/8
\FOR_Y					; Boucle_Y pour affichage de la lettre
	move.w	d4,d3			; Utilisation de D3 pour la boucle
\FOR_X
	clr.w		d1
	move.b	(a4)+,d1		; Passage du segment en D1
	move.b	#8,d2			; D2 = 8
	sub.b		d7,d2			; D2 = 8 - D7 (pour dcalage gauche)
	lsl.w		d2,d1
	move.b	couleur,d2
	tst.b		d2
	beq		\Put_White
	cmp.b		#1,d2
	beq		\Put_LightGray
	cmp.b		#2,d2
	beq		\Put_DarkGray
	or.b		d1,1(a0)		; Affichage en surimpression sur ecran1
	or.b		d1,1(a1)		; Affichage en surimpression sur ecran2
	lsr.w		#8,d1			; Evite les adresses impaires
	or.b		d1,(a0)+		; Affichage en surimpression sur ecran1
	or.b		d1,(a1)+		; Affichage en surimpression sur ecran2
	dbra.s		d3,\FOR_X		; Fin de boucle utilisant D3
	bra.s		\Put_ColorOK
\Put_DarkGray
	move.w	d1,d2
	not.w		d1
	and.b		d1,1(a0)		; Affichage en surimpression sur ecran1
	or.b		d2,1(a1)		; Affichage en surimpression sur ecran2
	lsr.w		#8,d1			; Evite les adresses impaires
	lsr.w		#8,d2			; Evite les adresses impaires
	and.b		d1,(a0)+		; Affichage en surimpression sur ecran1
	or.b		d2,(a1)+		; Affichage en surimpression sur ecran2
	dbra.s		d3,\FOR_X		; Fin de boucle utilisant D3
	bra.s		\Put_ColorOK
\Put_LightGray
	move.w	d1,d2
	not.w		d2
	or.b		d1,1(a0)		; Affichage en surimpression sur ecran1
	and.b		d2,1(a1)		; Affichage en surimpression sur ecran2
	lsr.w		#8,d1			; Evite les adresses impaires
	lsr.w		#8,d2			; Evite les adresses impaires
	or.b		d1,(a0)+		; Affichage en surimpression sur ecran1
	and.b		d2,(a1)+		; Affichage en surimpression sur ecran2
	dbra.s		d3,\FOR_X		; Fin de boucle utilisant D3
	bra.s		\Put_ColorOK
\Put_White
	not.w		d1
	and.b		d1,1(a0)		; Affichage en surimpression sur ecran1
	and.b		d1,1(a1)		; Affichage en surimpression sur ecran2
	lsr.w		#8,d1			; Evite les adresses impaires
	and.b		d1,(a0)+		; Affichage en surimpression sur ecran1
	and.b		d1,(a1)+		; Affichage en surimpression sur ecran2
	dbra.s		d3,\FOR_X		; Fin de boucle utilisant D3
\Put_ColorOK
	adda.w		#29,a0			; Passage  la ligne suivante
	sub.w		d4,a0
	adda.w		#29,a1			; Passage  la ligne suivante
	sub.w		d4,a1
	dbra.s		d0,\FOR_Y		; Fin de boucle utilisant D0
	movem.l	(a7)+,a0-a1		; Restauration de la position des cran
	clr.w		d0
	move.b	(a3),d0			; D0 = Taille X de la fonte
	move.l		a0,-(a7)
	lea		var_table,a0
	clr.w		d1
	move.b	VAR_CurseurX(a0),d1	; D1 = Position X du curseur
	add.b		d0,d1			; D1 = D0 + D1
	move.b	d1,VAR_CurseurX(a0)	; Nouvelle position du curseur
	move.l		(a7)+,a0
	move.l		6(a3),a6		; A6 = Pointeur sur table de correction
	clr.w		d3
	move.b	(a5),d3			; D3 = Caractre  corriger
	move.b	(a6),d1			; D1 = Teste si correction
	tst.b		d1
	beq		\Correction_OK	; Si D1 = 0 alors pas de correction
	move.b	0(a6,d3.w),d2		; Rcupre l'indice de correction
	move.l		a0,-(a7)
	lea		var_table,a0
	clr.w		d1
	move.b	VAR_CurseurX(a0),d1	; D1 = Position X du curseur
	add.b		d2,d1			; D1 = D1 + D2
	move.b	d1,VAR_CurseurX(a0)	; Nouvelle position du curseur
	move.l		(a7)+,a0
	add.b		d2,d7			; Effectue la correction
\Correction_OK
	add.b		d0,d7			; D7 = Dcalage
	move.b	d7,d0			; D0 = D7
	lsr.b		#3,d0			; Quotient de D7/8
	and.b		#7,d7			; Reste de D7/8
	adda.w		d0,a0			; Repositionne cran1
	adda.w		d0,a1			; Repositionne cran2
	lea		1(a5),a5		; A5 = A5 + 1
	bra		\LOOP			; Retour de boucle
\END_LOOP
	lea		1(a5),a5
	move.l		a5,P_String
	rts

\TAGS_DETECTED
	cmp.b		#EndDialog,d0
	beq		\END_LOOP
	cmp.b		#UseName,d0
	beq		\USE_NAME
	cmp.b		#SetDialog,d0
	beq		\SET_DIALOG
	cmp.b		#CenterText,d0
	beq		\CENTER_TEXT
	cmp.b		#ChangeFont,d0
	beq		\CHANGE_FONT
	cmp.b		#ChangeColor,d0
	beq		\CHANGE_COLOR
	cmp.b		#ChangeDelay,d0
	beq		\CHANGE_DELAY
	cmp.b		#ClearBox,d0
	beq		\CLEAR_BOX
	cmp.b		#PutImage,d0
	beq		\PUT_IMAGE
	cmp.b		#SaveImage,d0
	beq		\SAVE_IMAGE
	cmp.b		#CursorXY,d0
	beq		\CURSOR_XY
	cmp.b		#JumpLine,d0
	beq		\JUMP_LINE
	cmp.b		#PutBox,d0
	beq		\PUT_BOX
	cmp.b		#WaitKey,d0
	beq		\WAIT_KEY
	cmp.b		#LoadCurrentName,d0
	beq		\LOAD_CURRENT_NAME
	cmp.b		#UseCurrentName,d0
	beq		\USE_CURRENT_NAME
	cmp.b		#WaitDialog,d0
	beq		\WAIT_DIALOG
	cmp.b		#MoveVal,d0
	beq		\MOVE_VAL
	cmp.b		#CmpVal,d0
	beq		\CMP_VAL
	cmp.b		#CalcVal,d0
	beq		\CALC_VAL
	cmp.b		#Label,d0
	beq		\LABEL
	cmp.b		#SaveOnStack,d0
	beq		\SAVE_ON_STACK
	cmp.b		#GoOnStack,d0
	beq		\GO_ON_STACK
	cmp.b		#RestoreStack,d0
	beq		\RESTORE_STACK
	cmp.b		#PlaceCursor,d0
	beq		\PLACE_CURSOR
	cmp.b		#EraseCursor,d0
	beq		\ERASE_CURSOR
	cmp.b		#RunDialog,d0
	beq		\RUN_DIALOG
	cmp.b		#GetName,d0
	beq		\GET_NAME
	cmp.b		#PutCharPointer,d0
	beq		\PUT_CHAR_POINTER
	cmp.b		#GestVBoard,d0
	beq		\GEST_VBOARD
	cmp.b		#StoreNewName,d0
	beq		\STORE_NEW_NAME
	cmp.b		#Goto,d0
	beq		\GOTO

	cmp.b		#ClearScreen,d0
	bne		\DEBUG
	movem.l	a0-a1,-(a7)
	move.l		ecran1,a0
	move.l		ecran2,a1
	move.w	#959,d0

\LOOP_FILL
	move.l		#$FFFFFFFF,(a0)+
	move.l		#$FFFFFFFF,(a1)+
	dbra		d0,\LOOP_FILL
	movem.l	(a7)+,a0-a1
	bra		\END_TAGS

\DEBUG						; Pour le debugage
	cmp.b		#Debug,d0
	beq		\DEBUG
	bra		\END_TAGS

\USE_NAME
	lea		1(a5),a5
	movem.l	d0-d7/a2-a6,-(a7)
	move.l		P_String,-(a7)
	clr.w		d0
	move.b	(a5),d0
	lsl.w		#2,d0
	lea		NameTable,a0
	move.l		0(a0,d0.w),P_String
	bsr		StartDialog
	move.l		(a7)+,P_String
	movem.l	(a7)+,d0-d7/a2-a6
	bsr		Pos_CursorXY
	bra		\END_TAGS

\SET_DIALOG
	movem.l	d0-d7/a2-a6,-(a7)
	move.b	#3,couleur
	move.b	#0,style
	move.b	#10,delay
	Set_Cursor	#1,#1
	lea		FontTable,a2
	move.b	#0,small_font_active
	IFD ti89
	lea		10(a2),a2
	ENDIF
	IFND ti89
	lea		20(a2),a2
	ENDIF
	move.l		a2,d0
	Use_Font	d0
	lea		current_screen,a2
	move.b	#0,(a2)+
	move.b	#0,(a2)+
	move.b	#XSCREEN*8,(a2)+
	move.b	#YSCREEN,(a2)
	movem.l	(a7)+,d0-d7/a2-a6
	bsr		Pos_CursorXY
	lea		current_font,a2	; A2 = Pointeur sur TypeFonte
	move.l		(a2),a3			; A3 = TypeFonte
	bra		\END_TAGS

\CENTER_TEXT
	move.l		a5,-(a7)
	lea		1(a5),a5		; Caractre suivant
	moveq.w	#0,d1			; Compteur de caractres
\SearchNextTags
	move.b	(a5)+,d0
	cmp.b		#127,d0
	bhi		\End_SearchTags
	addq.b		#1,d1
	bra		\SearchNextTags
\End_SearchTags
	clr.w		d0
	move.b	(a3),d0			; Taille X de la fonte
	mulu.w		d0,d1			; Nb.Chars * Taille X
	lsr.w		#1,d1			; Nombres de caractres / 2
	lea		current_screen,a5
	clr.w		d2
	clr.w		d3
	move.b	(a5),d2
	subq.b		#Marge_X,d2
	move.b	2(a5),d3
	lsr.w		#1,d3
	cmp.b		d3,d1
	bhi		\NoCenter
	sub.b		d1,d3
	add.b		d2,d3
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	d3,VAR_CurseurX(a0)
	move.l		(a7)+,a0
	bsr		Pos_CursorXY
\NoCenter
	move.l		(a7)+,a5
	bra		\END_TAGS

\CHANGE_FONT
	lea		1(a5),a5
	clr.w		d0
	move.b	(a5),d0
	movem.l	a0-a1,-(a7)
	lea		FontTable,a0
	move.b	#1,small_font_active
	tst.b		d0
	beq		\Correction_Mini
	move.b	#0,small_font_active
\Correction_Mini
	mulu.w		#10,d0
	add.l		a0,d0
	Use_Font	d0
	movem.l	(a7)+,a0-a1
	lea		current_font,a2	; A2 = Pointeur sur TypeFonte
	move.l		(a2),a3			; A3 = TypeFonte
	bra		\END_TAGS

\CHANGE_COLOR
	lea		1(a5),a5
	move.b	(a5),couleur
	bra		\END_TAGS

\CHANGE_DELAY
	lea		1(a5),a5
	move.b	(a5),delay
	bra		\END_TAGS

\CLEAR_BOX
	movem.l	a2-a6,-(a7)
	lea		current_box,a0	; Pointeur sur la structure de la bote
	move.l		ecran1,a2
	move.l		ecran2,a1
	bsr		draw_box
	clr.w		d0
	clr.w		d1
	lea		current_screen,a0
	move.b	(a0),d0
	move.b	1(a0),d1
	Set_Cursor	d0,d1
	movem.l	(a7)+,a2-a6
	bsr		Pos_CursorXY
	bra		\END_TAGS

\PUT_IMAGE
	lea		1(a5),a5
	move.l		a2,-(a7)
	lea		ImageTable,a2
	clr.w		d0
	move.b	(a5),d0
	lsl.w		#2,d0
	move.l		0(a2,d0.w),a2		; A2 = Pointeur sur image
	move.w	#0,-(a7)
	bra		\No_PDI
\PUT_DIRECT_IMAGE				; Ncessite sauvegarde de A2 sur pile
	move.w	#1,-(a7)
\No_PDI
	clr.w		d1
	clr.w		d2
	clr.w		d3
	move.b	(a2)+,d2
	move.b	(a2)+,d1
	move.b	(a2)+,d3
	move.w	d3,-(a7)
\LOOP_Y_Pic
	move.w	d2,d0
	subq.b		#1,d0
\LOOP_X_Pic
	clr.w		d5
	clr.w		d6
	move.b	(a2),d5
	move.b	0(a2,d2.w),d6
	lea		1(a2),a2
	move.b	d5,d4
	or.b		d6,d4
	move.w	(a7),d3
	tst.b		d3
	beq		\BitMapMask
	move.w	#$FF,d4
\BitMapMask
	move.b	#8,d3			; D3 = 8
	sub.b		d7,d3			; D3 = 8 - D7 (pour dcalage gauche)
	lsl.w		d3,d4
	lsl.w		d3,d5
	lsl.w		d3,d6
	not.w		d4
	and.b		d4,1(a0)
	and.b		d4,1(a1)
	lsr.w		#8,d4
	and.b		d4,(a0)
	and.b		d4,(a1)
	or.b		d5,1(a0)
	or.b		d6,1(a1)
	lsr.w		#8,d5
	lsr.w		#8,d6
	or.b		d5,(a0)+
	or.b		d6,(a1)+
	dbra.s		d0,\LOOP_X_Pic
	adda.w		d2,a2
	moveq.w	#30,d4
	sub.b		d2,d4
	adda.w		d4,a0
	adda.w		d4,a1
	dbra.s		d1,\LOOP_Y_Pic
	lea		2(a7),a7
	move.l		a0,-(a7)
	lea		var_table,a0
	clr.w		d0
	move.b	VAR_CurseurX(a0),d0	; D1 = Position X du curseur
	lsl.b		#3,d2
	add.b		d2,d0
	move.b	d0,VAR_CurseurX(a0)	; Nouvelle position du curseur
	move.l		(a7)+,a0
	bsr		Pos_CursorXY
	move.w	(a7)+,d0
	tst.b		d0
	bne		\END_PDI
	move.l		(a7)+,a2
	bra		\END_TAGS
\END_PDI
	rts

\SAVE_IMAGE
	lea		1(a5),a5
	move.l		a2,-(a7)
	lea		ImageTable,a2
	clr.w		d0
	move.b	2(a5),d0
	lsl.w		#2,d0
	move.l		0(a2,d0.w),a2		; A2 = Pointeur sur image
	move.b	(a5),(a2)
	move.b	1(a5),d0
	sub		#1,d0
	move.b	d0,1(a2)
	lea		2(a5),a5
	move.w	#0,-(a7)
	bra		\No_SDI
\SAVE_DIRECT_IMAGE			; Ncessite sauvegarde de A2 sur pile
	move.w	#1,-(a7)
\No_SDI
	movem.l	a0-a1,-(a7)
	clr.w		d1
	clr.w		d2
	move.b	(a2)+,d2
	move.b	(a2)+,d1
	lea		1(a2),a2
\LOOP_Y_Sav
	move.w	d2,d0
	subq.b		#1,d0
\LOOP_X_Sav
	clr.w		d5
	clr.w		d6
	move.b	(a0),d5
	move.b	(a1),d6
	lsl.w		#8,d5
	lsl.w		#8,d6
	move.b	1(a0),d5
	move.b	1(a1),d6
	move.b	#8,d4
	sub		d7,d4
	lsr.w		d4,d5
	lsr.w		d4,d6
	move.b	d5,(a2)
	move.b	d6,0(a2,d2.w)
	lea		1(a0),a0
	lea		1(a1),a1
	lea		1(a2),a2
	dbra.s		d0,\LOOP_X_Sav
	adda.w		d2,a2
	moveq.w	#30,d4
	sub.b		d2,d4
	adda.w		d4,a0
	adda.w		d4,a1
	dbra.s		d1,\LOOP_Y_Sav
	movem.l	(a7)+,a0-a1
	move.w	(a7)+,d0
	tst.b		d0
	bne		\END_SDI
	move.l		(a7)+,a2
	bra		\END_TAGS
\END_SDI
	rts

\CURSOR_XY
	move.b	1(a5),d0		; Type d'opration
	lea		var_table,a0		; Oprations gnriques...
	lea		current_screen,a1	; ...pour l'optimisation
	cmp.b		#Absolute_IMM,d0
	beq		\AbsIMM_MouvX
	cmp.b		#Relative_IMM,d0
	beq		\RevIMM_MouvX
	cmp.b		#Absolute_VAR,d0
	beq		\AbsVAR_MouvX
\RevVAR_MouvX
	clr.w		d0
	move.b	2(a5),d0
	move.b	0(a0,d0.w),d0
	move.b	VAR_CurseurX(a0),d1
	add		d0,d1			; Valeur + Xo boite
	move.b	d1,VAR_CurseurX(a0)	; X positionn
	bra		\Cursor_CalcY
\AbsIMM_MouvX
	move.b	2(a5),d0
	move.b	(a1),d1
	add		d0,d1			; Valeur + Xo boite
	move.b	d1,VAR_CurseurX(a0)	; X positionn
	bra		\Cursor_CalcY
\RevIMM_MouvX
	move.b	2(a5),d0
	move.b	VAR_CurseurX(a0),d1
	add		d0,d1			; Valeur + X Curseur
	move.b	d1,VAR_CurseurX(a0)	; X positionn
	bra		\Cursor_CalcY
\AbsVAR_MouvX
	clr.w		d0
	move.b	2(a5),d0
	move.b	0(a0,d0.w),d0
	move.b	(a1),d1
	add		d0,d1			; Valeur + Xo boite
	move.b	d1,VAR_CurseurX(a0)	; X positionn
\Cursor_CalcY
	move.b	3(a5),d0		; Type d'opration
	cmp.b		#Absolute_IMM,d0
	beq		\AbsIMM_MouvY
	cmp.b		#Relative_IMM,d0
	beq		\RevIMM_MouvY
	cmp.b		#Absolute_VAR,d0
	beq		\AbsVAR_MouvY
\RevVAR_MouvY
	clr.w		d0
	move.b	4(a5),d0
	move.b	0(a0,d0.w),d0
	move.b	VAR_CurseurY(a0),d1
	add		d0,d1			; Valeur + Yo boite
	move.b	d1,VAR_CurseurY(a0)	; Y positionn
	bra		\EndCursor_Calc
\AbsIMM_MouvY
	move.b	4(a5),d0
	move.b	1(a1),d1
	add		d0,d1			; Valeur + Yo boite
	move.b	d1,VAR_CurseurY(a0)	; Y positionn
	bra		\EndCursor_Calc
\RevIMM_MouvY
	move.b	4(a5),d0
	move.b	VAR_CurseurY(a0),d1
	add		d0,d1			; Valeur + Y Curseur
	move.b	d1,VAR_CurseurY(a0)	; Y positionn
	bra		\EndCursor_Calc
\AbsVAR_MouvY
	clr.w		d0
	move.b	4(a5),d0
	move.b	0(a0,d0.w),d0
	move.b	1(a1),d1
	add		d0,d1			; Valeur + Yo boite
	move.b	d1,VAR_CurseurY(a0)	; Y positionn
\EndCursor_Calc
	lea		4(a5),a5
	bsr		Pos_CursorXY
	bra		\END_TAGS

\JUMP_LINE
	move.b	1(a3),d0		; D0 = Taille Y de la fonte
	move.b	small_font_active,d1	; D1 = Correction de fonte
	sub.b		d1,d0			; D0 = D0 - D1
	addq.b		#Interligne,d0		; D0 = D0 + Interligne
	move.l		a0,-(a7)
	lea		var_table,a0
	clr.w		d2
	move.b	VAR_CurseurY(a0),d2	; D2 = Position Y du curseur
	move.l		(a7)+,a0
	add.b		d0,d2			; D2 = D0 + D2
	move.l		a2,-(a7)
	lea		current_screen,a2
	move.b	1(a2),d1
	move.b	3(a2),d3
	add		d1,d3
	move.b	1(a3),d1		; D0 = Taille Y de la fonte
	sub		#Marge_Y+3,d3
	sub		d1,d3
	cmp.b		d2,d3
	bls		\NeedNewBox
	clr.w		d0
	move.b	(a2),d0
	Set_Cursor d0,d2
	move.l		(a7)+,a2
	bsr		Pos_CursorXY
	bra		\END_TAGS
\NeedNewBox
	move.l		(a7)+,a2
	bra		\WAIT_DIALOG

\PUT_BOX
	lea		1(a5),a5
	movem.l	a2-a6,-(a7)
	lea		BoxTable,a0		; Pointeur sur la structure de la bote
	clr.w		d0
	move.b	(a5),d0
	lsl.b		#2,d0
	adda.w		d0,a0
	lea		current_box,a1
	move.l		(a0),(a1)
	lea		current_screen,a1
	clr.w		d0
	clr.w		d1
	move.b	(a0)+,d0
	lsl.b		#3,d0
	addq.b		#Marge_X,d0
	move.b	d0,(a1)+
	move.b	(a0)+,d1
	addq.b		#Marge_Y,d1
	move.b	d1,(a1)+
	Set_Cursor	d0,d1
	move.b	(a0)+,d0
	lsl.b		#3,d0
	move.b	d0,(a1)+
	move.b	(a0),(a1)
	suba.w		#3,a0
	move.l		ecran1,a2
	move.l		ecran2,a1
	bsr		draw_box
	movem.l	(a7)+,a2-a6
	bsr		Pos_CursorXY
	bra		\END_TAGS

\WAIT_KEY
;	jsr		flib::idle_loop		; A remplacer par une routine
						; qui place la valeur de la touche
;	cmp.w		#ENTER_f,d0		; dans D0.b
;	beq		\Genlib_ENTER	; ...
;	cmp.w		#LEFT_f,d0		; ...
;	beq		\Genlib_LEFT		; ...
;	cmp.w		#RIGHT_f,d0		; ...
;	beq		\Genlib_RIGHT	; ...
;	cmp.w		#UP_f,d0		; ...
;	beq		\Genlib_UP		; ...
;	cmp.w		#DOWN_f,d0		; ...
;	beq		\Genlib_DOWN	; ...
;	bra		\Genlib_End		; ...
;\Genlib_ENTER				; ...
;	move.b	#ENTER,d0		; ...
;	bra		\Genlib_End		; ...
;\Genlib_LEFT					; ...
;	move.b	#LEFT,d0		; ...
;	bra		\Genlib_End		; ...
;\Genlib_RIGHT				; ...
;	move.b	#RIGHT,d0		; ...
;	bra		\Genlib_End		; ...
;\Genlib_UP					; ...;
;	move.b	#UP,d0			; ...
;	bra		\Genlib_End		; ...
;\Genlib_DOWN				; ...
;	move.b	#DOWN,d0		; ...
;	bra		\Genlib_End		; ...
;\Genlib_End					; ...
	bsr	GetKey
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	d0,VAR_KeyBuffer(a0)
	move.l		(a7)+,a0
	bra		\END_TAGS

\LOAD_CURRENT_NAME
	lea		1(a5),a5
	move.w	#0,-(a7)
	bra		\No_LCNI
\LOAD_CURRENT_NAME_Fast
	move.w	#1,-(a7)
\No_LCNI
	movem.l	a0-a1,-(a7)
	clr.w		d0
	move.b	(a5),d0
	lsl.w		#2,d0
	lea		NameTable,a0
	move.l		0(a0,d0.w),a0
	lea		current_name,a1
\Loop_LoadCN
	move.b	(a0)+,d0
	cmp.b		#127,d0
	bhi		\End_Loop_LoadCN
	move.b	d0,(a1)+
	bra		\Loop_LoadCN
\End_Loop_LoadCN
	move.w	8(a7),d0
	tst.b		d0
	bne		\Go_LCNI
	move.b	#":",(a1)+
	move.b	#32,(a1)+		; Espace
\Go_LCNI
	move.b	#EndDialog,(a1)
	movem.l	(a7)+,a0-a1
	move.w	(a7)+,d0
	tst.b		d0
	beq		\END_TAGS
	rts

\USE_CURRENT_NAME
	movem.l	d0-d7/a2-a6,-(a7)
	move.l		P_String,-(a7)
	lea		current_name,a0
	move.l		a0,P_String
	clr.w		d0
	move.b	couleur,d0
	move.w	d0,-(a7)
	move.b	#DarkGray,couleur
	bsr		StartDialog
	move.w	(a7)+,d0
	move.b	d0,couleur
	move.l		(a7)+,P_String
	movem.l	(a7)+,d0-d7/a2-a6
	bsr		Pos_CursorXY
	bra		\END_TAGS

\WAIT_DIALOG
	jsr		flib::idle_loop
	bra		\CLEAR_BOX

\MOVE_VAL
	move.b	1(a5),d0
	cmp.b		#IMM,d0
	beq		\MoveVal_Imm
\MoveVal_Var
	clr.w		d0
	move.b	2(a5),d0
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	0(a0,d0.w),d0		; D0 = Valeur
	move.l		(a7)+,a0
	bra		\MoveGetVal_Ok
\MoveVal_Imm
	move.b	2(a5),d0		; D0 = Valeur
\MoveGetVal_Ok
	clr.w		d1
	move.b	3(a5),d1
	move.l		a0,-(a7)
	lea		var_table,a0
	adda.w		d1,a0
	move.b	d0,(a0)
	move.l		(a7)+,a0
	lea		3(a5),a5
	bra		\END_TAGS

\CMP_VAL
	move.b	1(a5),d0
	cmp.b		#IMM,d0
	beq		\CmpVal_Imm
\CmpVal_Var
	clr.w		d0
	move.b	2(a5),d0
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	0(a0,d0.w),d0		; D0 = Valeur
	move.l		(a7)+,a0
	bra		\CmpGetVal_Ok
\CmpVal_Imm
	move.b	2(a5),d0		; D0 = Valeur
\CmpGetVal_Ok
	move.b	4(a5),d1
	clr.w		d2
	move.b	3(a5),d2
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	0(a0,d2.w),d2		; D2 = Valeur
	move.l		(a7)+,a0
	cmp.b		#BEQ_b,d1
	beq		\CmpBEQ
	cmp.b		#BNE_b,d1
	beq		\CmpBNE
	cmp.b		#BHI_b,d1
	beq		\CmpBHI
\CmpBLS
	cmp.b		d2,d0
	bls		\Search_Label
	lea		5(a5),a5
	bra		\END_TAGS
\CmpBEQ
	cmp.b		d0,d2
	beq		\Search_Label
	lea		5(a5),a5
	bra		\END_TAGS
\CmpBNE
	cmp.b		d0,d2
	bne		\Search_Label
	lea		5(a5),a5
	bra		\END_TAGS
\CmpBHI
	cmp.b		d2,d0
	bhi		\Search_Label
	lea		5(a5),a5
	bra		\END_TAGS
\Search_Label
	move.b	5(a5),d0
\LoopSearch_Label
	move.b	(a5)+,d1
	cmp.b		#Label,d1
	beq		\Label_Found
	bra		\LoopSearch_Label
\Label_Found
	move.b	(a5),d1
	cmp.b		d0,d1
	bne		\LoopSearch_Label
	bra		\END_TAGS

\CALC_VAL
	move.b	1(a5),d0
	cmp.b		#IMM,d0
	beq		\CalcVal_Imm
\CalcVal_Var
	clr.w		d0
	move.b	2(a5),d0
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	0(a0,d0.w),d0		; D0 = Valeur 1
	move.l		(a7)+,a0
	bra		\CalcGetVal_Ok
\CalcVal_Imm
	clr.w		d0
	move.b	2(a5),d0		; D0 = Valeur 1
\CalcGetVal_Ok
	clr.w		d1
	move.b	4(a5),d1
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	0(a0,d1.w),d1		; D1 = Valeur 2
	move.l		(a7)+,a0
	move.b	3(a5),d2		; Calcul  effectuer
	cmp.b		#ADD_o,d2
	beq		\CalcADD
	cmp.b		#SUB_o,d2
	beq		\CalcSUB
	cmp.b		#MUL_o,d2
	beq		\CalcMUL
	cmp.b		#DIV_o,d2
	beq		\CalcDIV
\CalcMOD
	divu.b		d0,d1
	swap		d1
	bra		\CalcResult
\CalcADD
	add.b		d0,d1
	bra		\CalcResult
\CalcSUB
	sub.b		d0,d1
	bra		\CalcResult
\CalcMUL
	mulu.b		d0,d1
	bra		\CalcResult
\CalcDIV
	divu.b		d0,d1
	bra		\CalcResult
\CalcResult
	clr.w		d2
	move.b	4(a5),d2
	move.l		a0,-(a7)
	lea		var_table,a0
	adda.w		d2,a0
	move.b	d1,(a0)
	move.l		(a7)+,a0
	lea		4(a5),a5
	bra		\END_TAGS

\LABEL
	lea		1(a5),a5
	bra		\END_TAGS

\SAVE_ON_STACK
	move.l		a5,-(a7)
	bra		\END_TAGS

\GO_ON_STACK
	move.l		(a7),a5
	move.l		a5,P_String
	bra		\END_TAGS

\RESTORE_STACK
	lea		4(a7),a7
	bra		\END_TAGS

\PLACE_CURSOR
	move.l		a2,-(a7)
	Get_Cursor d0,d1			; Sauvegarde du curseur
	movem.w	d0-d1,-(a7)
	move.w	d0,Old_CurX
	move.w	d1,Old_CurY
	lea		curseur_picoff,a2
	bsr		\SAVE_DIRECT_IMAGE
	movem.w	(a7)+,d0-d1
	Set_Cursor d0,d1			; restauration du curseur
	bsr		Pos_CursorXY
	lea		curseur_picon,a2
	bsr		\PUT_DIRECT_IMAGE
	move.l		(a7)+,a2
	bra		\END_TAGS

\ERASE_CURSOR
	move.l		a2,-(a7)
	Get_Cursor d0,d1			; Sauvegarde du curseur
	movem.w	d0-d1,-(a7)
	move.w	Old_CurX,d0
	move.w	Old_CurY,d1
	Set_Cursor d0,d1			; Restauration du old_curseur
	bsr		Pos_CursorXY
	lea		curseur_picoff,a2
	bsr		\PUT_DIRECT_IMAGE
	movem.w	(a7)+,d0-d1
	Set_Cursor d0,d1			; restauration du old_curseur
	bsr		Pos_CursorXY
	move.l		(a7)+,a2
	bra		\END_TAGS

\RUN_DIALOG
	lea		1(a5),a5
	movem.l	d0-d7/a2-a6,-(a7)
	move.l		P_String,-(a7)
	lea		DialogTable,a0
	clr.w		d0
	move.b	(a5),d0
	move.l		0(a0,d0.w),d0
	move.l		d0,P_String
	bsr		StartDialog
	move.l		(a7)+,P_String
	movem.l	(a7)+,d0-d7/a2-a6
	bsr		Pos_CursorXY
	bra		\END_TAGS

\GET_NAME
	lea		1(a5),a5
	move.b	#0,get_nameCharP
	move.b	(a5),get_namePos
	bsr		\LOAD_CURRENT_NAME_Fast
	movem.l	d0-d7/a2-a6,-(a7)
	move.l		P_String,-(a7)
	lea		GetName_Dial,a0
	move.l		a0,P_String
	bsr		StartDialog
	move.l		(a7)+,P_String
	movem.l	(a7)+,d0-d7/a2-a6
	bsr		Pos_CursorXY
	bra		\END_TAGS

\PUT_CHAR_POINTER
	move.l		a2,-(a7)
	clr.w		d0
	clr.w		d1
	clr.w		d2
	clr.w		d3
	lea		1(a5),a5
	move.b	(a5)+,d0
	move.b	(a5)+,d1
	move.b	(a5),d2
	move.b	get_nameCharP,d3
	mulu		d3,d1
	add		d0,d1
	Set_Cursor 	d1,d2
	bsr		Pos_CursorXY
	lea		char_pointer,a2
	bsr		\PUT_DIRECT_IMAGE
	move.l		(a7)+,a2
	bra		\END_TAGS

\GEST_VBOARD
	move.l		a2,-(a7)
	clr.w		d0
	clr.w		d1
	move.l		a0,-(a7)
	lea		var_table,a0
	move.b	VAR_PosCurseurX(a0),d0
	move.b	VAR_PosCurseurY(a0),d1
	move.l		(a7)+,a0
	mulu		#12,d1
	add		d1,d0
	cmp.b		#25,d0
	bls		\Add_Minus
	cmp.b		#25+26,d0
	bls		\Add_Majus
	cmp.b		#52,d0
	beq		\Add_Excla
	cmp.b		#53,d0
	beq		\Add_Inter
	cmp.b		#54,d0
	beq		\Add_Etoile
	cmp.b		#55,d0
	beq		\Add_Carre
	cmp.b		#56,d0
	beq		\Add_Espace
	cmp.b		#57,d0
	beq		\Dec_CharP
	cmp.b		#58,d0
	beq		\Inc_CharP
\Add_Minus
	clr.w		d1
	move.b	get_nameCharP,d1
	lea		current_name,a2
	adda.w		d1,a2
	add		#97,d0
	move.b	d0,(a2)
	move.l		(a7)+,a2
	cmp.b		#4,d1
	bne		\Inc_GetName
	bra		\END_TAGS
\Add_Majus
	add		#65-26,d0
	clr.w		d1
	move.b	get_nameCharP,d1
	lea		current_name,a2
	adda.w		d1,a2
	move.b	d0,(a2)
	move.l		(a7)+,a2
	cmp.b		#4,d1
	bne		\Inc_GetName
	bra		\END_TAGS
\Add_Excla
	clr.w		d1
	move.b	get_nameCharP,d1
	lea		current_name,a2
	adda.w		d1,a2
	move.b	#33,(a2)
	move.l		(a7)+,a2
	cmp.b		#4,d1
	bne		\Inc_GetName
	bra		\END_TAGS
\Add_Inter
	clr.w		d1
	move.b	get_nameCharP,d1
	lea		current_name,a2
	adda.w		d1,a2
	move.b	#63,(a2)
	move.l		(a7)+,a2
	cmp.b		#4,d1
	bne		\Inc_GetName
	bra		\END_TAGS
\Add_Etoile
	clr.w		d1
	move.b	get_nameCharP,d1
	lea		current_name,a2
	adda.w		d1,a2
	move.b	#42,(a2)
	move.l		(a7)+,a2
	cmp.b		#4,d1
	bne		\Inc_GetName
	bra		\END_TAGS
\Add_Carre
	clr.w		d1
	move.b	get_nameCharP,d1
	lea		current_name,a2
	adda.w		d1,a2
	move.b	#16,(a2)
	move.l		(a7)+,a2
	cmp.b		#4,d1
	bne		\Inc_GetName
	bra		\END_TAGS
\Add_Espace
	clr.w		d1
	move.b	get_nameCharP,d1
	lea		current_name,a2
	adda.w		d1,a2
	move.b	#32,(a2)
	move.l		(a7)+,a2
	cmp.b		#4,d1
	bne		\Inc_GetName
	bra		\END_TAGS
\Dec_CharP
	clr.w		d1
	move.b	get_nameCharP,d1
	move.l		(a7)+,a2
	tst.b		d1
	beq		\END_TAGS
	sub		#1,d1
	move.b	d1,get_nameCharP
	bra		\END_TAGS
\Inc_CharP
	clr.w		d1
	move.b	get_nameCharP,d1
	move.l		(a7)+,a2
	cmp.b		#4,d1
	beq		\END_TAGS
	add		#1,d1
	move.b	d1,get_nameCharP
	bra		\END_TAGS
\Inc_GetName
	add		#1,d1
	move.b	d1,get_nameCharP
	bra		\END_TAGS

\STORE_NEW_NAME
	movem.l	a2-a3,-(a7)
	lea		current_name,a2
	lea		NameTable,a3
	clr.w		d0
	move.b	get_namePos,d0
	lsl.w		#2,d0
	move.l		0(a3,d0.w),a3
	move.b	(a2)+,(a3)+
	move.b	(a2)+,(a3)+
	move.b	(a2)+,(a3)+
	move.b	(a2)+,(a3)+
	move.b	(a2)+,(a3)+
	move.w	#4,d0
\Loop_SSpaceName
	sub		#1,a3
	move.b	(a3),d1
	cmp.b		#32,d1
	bne		\End_SSpaceName
	dbra		d0,\Loop_SSpaceName
\End_SSpaceName
	add		#1,a3
	move.b	#EndDialog,(a3)
	movem.l	(a7)+,a2-a3
	bra		\END_TAGS

\GOTO
	lea		1(a5),a5
	move.b	(a5),d0
\GotoLabel
	move.b	(a5)+,d1
	cmp.b		#Label,d1
	beq		\GotoLabelFound
	bra		\GotoLabel
\GotoLabelFound
	move.b	(a5),d1
	cmp.b		d0,d1
	beq		\END_TAGS
	bra		\GotoLabel

\END_TAGS
	lea		1(a5),a5
	bra		\LOOP

\SPACE_DETECTED
	move.l		a5,-(a7)
	lea		1(a5),a5		; Caractre suivant
	moveq.w	#2,d1			; Compteur de caractres
\SearchNextSpace
	move.b	(a5)+,d0
	cmp.b		#32,d0
	beq		\End_Search
	cmp.b		#127,d0
	bhi		\End_Search
	addq.b		#1,d1
	bra		\SearchNextSpace
\End_Search
	clr.w		d0
	move.b	(a3),d0			; Taille X de la fonte
	mulu.w		d0,d1			; Nb.Chars * Taille X
	move.l		a0,-(a7)
	lea		var_table,a0
	clr.w		d2
	move.b	VAR_CurseurX(a0),d2	; D1 = Position X du curseur
	move.l		(a7)+,a0
	add.w		d1,d2
	lea		current_screen,a5
	clr.w		d0
	clr.w		d1
	move.b	(a5),d0
	move.b	2(a5),d1
	add.w		d0,d1
	sub.b		#Marge_X,d1
	cmp.w		d1,d2
	bhi		\Out_Box
\In_Box
	move.l		(a7)+,a5
	clr.w		d0
	move.b	(a5),d0
	bra		\SPACE_OK
\Out_Box
	move.l		(a7)+,a5
	bra		\JUMP_LINE