; ********************************************************
; Affichage de la bote de dialogue
; ********************************************************
; History:
;	v0.10 : Etan21
;	v0.11 : Optimisations diverses ! PpHd (j'ai craque !)
;
; --- draw_box ---
; Entre : A0 = Adresse de la boite
;	   A1 = Ecran 1
;	   A2 = Ecran 2
; Sortie : Aucune
; Detruit:
;	a1-a3/d0-d6
; ********************************************************

draw_box:
	move.l	a0,-(a7)		; Save 

	clr.w	d0
	clr.w	d1
	move.b	(a0)+,d0		; Position X
	move.b	(a0)+,d1		; Position Y

;--- Positionnement de la boite aux coordonnes X,Y
	mulu.w	#Taille_ecran,d1
	add.w	d1,d0
	adda.w	d0,a1			; Plane 0,1...
	adda.w	d0,a2			; ...positionns
	movem.l	a1-a2,-(a7)

;--- Initialisation
	lea	Texture(Pc),a3
	clr.w	d0
	move.b	(a0)+,d0		; Largeur de la boite+1
	subq.w	#1,d0			; Largeur de la boite
	clr.w	d1
	move.b	(a0)+,d1		; Hauteur de la boite+1
	subq.w	#1,d1			; Hauteur de la boite
	moveq	#Taille_ecran-1,d5
	sub.w	d0,d5				; Sauvegarde du reste = D5

	; Remplissage de la texture
	movem.w	d0-d1,-(a7)
	clr.w	d4
\LOOP_Y1
		move.w	d0,d2
		clr.w	d3
\LOOP_X
			clr.b	(a1)+
			move.b	0(a3,d3.w),(a2)+
			addq.w	#1,d3
			and.w	#3,d3
			dbra	d2,\LOOP_X
		lea	Texture(Pc),a3
		adda.w	d4,a3
		addq.w	#4,d4
		and.w	#127,d4
		adda.w	d5,a1
		adda.w	d5,a2
		dbra	d1,\LOOP_Y1

	movem.w	(a7)+,d0-d1			; On rcupre la taille de la boite
	movem.l	(a7)+,a1-a2			; On rcupre les adresse positionnes
	move.l	(a7)+,a0			; On recupere l'adresse de la boite

	; Affichage_du_contour

	subq.w	#2,d0

	lea	chg(Pc),a3				; Coin haut-gauche
	bsr	put_corner

	move.w	d0,d2
\LOOP_X1
		st.b	(a2)+
		clr.b	(a1)+
		clr.b	Taille_ecran-1(a2)
		clr.b	Taille_ecran-1(a1)
		clr.b	Taille_ecran*2-1(a2)
		st.b	Taille_ecran*2-1(a1)
		dbra	d2,\LOOP_X1

	lea	chd(Pc),a3				; Coin haut-droite
	bsr.s	put_corner

	move.w	d5,d6
	add.w	#60,d6
	adda.w	d6,a1
	adda.w	d6,a2
	move.w	d1,d2
	subq.w	#2*3,d2
	move.w	d0,d3
	addq.w	#2,d3
	addq.w	#1,d5
\LOOP_Y2
		and.b		#$1F,(a2)			; %00011111
		and.b		#$1F,(a1)			; %00011111
		or.b		#$80,(a2)			; %10000000
		or.b		#$20,(a1)			; %00100000
		add		d3,a1
		add		d3,a2
		and.b		#$F8,(a2)			; %11111000
		and.b		#$F8,(a1)			; %11111000
		or.b		#$3,(a2)			; %00000011
		or.b		#$5,(a1)			; %00000101
		add		d5,a1
		add		d5,a2
		dbra		d2,\LOOP_Y2

	lea	cbg(Pc),a3				; Coin bas-gauche
	bsr.s	put_corner

	move.w	d0,d2
\LOOP_X2
		clr.b	(a2)+
		st.b	(a1)+
		st.b	Taille_ecran-1(a2)
		clr.b	Taille_ecran-1(a1)
		st.b	Taille_ecran*2-1(a2)
		st.b	Taille_ecran*2-1(a1)
		dbra	d2,\LOOP_X2

	lea	cbd(Pc),a3				; Coin bas-droite

put_corner:
	move.b	(a3)+,(a2)+
	move.b	(a3)+,(a1)+
	move.b	(a3)+,Taille_ecran-1(a2)
	move.b	(a3)+,Taille_ecran-1(a1)
	move.b	(a3)+,Taille_ecran*2-1(a2)
	move.b	(a3),Taille_ecran*2-1(a1)
	rts
