demos::cf:
	; Initalisation partielle
	clr.w	genlib::sprite_scr_x
	clr.w	genlib::sprite_scr_y

	move.l	Screen_2(a6),d0
	jsr	genlib::set_dscreen_int
	jsr	genlib::set_dscreen_function
	jsr	genlib::cls

	move.l	Screen_1(a6),d0
	jsr	genlib::set_dscreen_function
	jsr	genlib::cls
	

	; Extraction des donnes
	lea	Data_shk(Pc),a0
	jsr	shrnklib::OpenArchive
	move.w	d0,d6
	beq	intro_quit

	; Les flammes : extraction + affichage + sauvegarde + libere mem
	moveq	#0,d1			; File 0
	suba.l	a0,a0		
	jsr	shrnklib::Extract
	cmp.l	d1,a0
	beq	intro_quit

	moveq	#0,d0
	moveq	#0,d1
	ifnd	ti89
		jsr	genlib::put_big_sprite
	endif
	ifd	ti89
		move.l	#(65536*240/160),d4
		move.l	#(65536*100/128),d5
		move.l	a0,a1
		jsr	genlib::put_big_sprite_zoom
	endif

	move.w	d2,d0
	bsr	Free

	move.l	Plan_A_adr(a6),a0
	move.l	Screen_1(a6),a1
	jsr	genlib::copy_dscreen_vscreen
	clr.w	PLANE_XS(a0)
	clr.w	PLANE_YS(a0)
	clr.w	PLANE_XS_OLD(a0)
	clr.w	PLANE_YS_OLD(a0)

	; Le logo: extraction + affichage + sauvegarde + libere mem
	moveq	#1,d1			; File 1
	suba.l	a0,a0		
	move.w	d6,d0
	jsr	shrnklib::Extract
	cmp.l	d1,a0
	beq	intro_quit

	moveq	#0,d0
	moveq	#0,d1
	jsr	genlib::cls
	ifnd	ti89
		jsr	genlib::put_big_sprite
	endif
	ifd	ti89
		move.l	#(65536*240/160),d4
		move.l	#(65536*100/128),d5
		move.l	a0,a1
		jsr	genlib::put_big_sprite_zoom
	endif

	move.w	d2,d0
	bsr	Free

	move.l	Plan_B_adr(a6),a0
	move.l	Screen_1(a6),a1
	jsr	genlib::copy_dscreen_vscreen
	clr.w	PLANE_XS(a0)
	clr.w	PLANE_YS(a0)
	clr.w	PLANE_XS_OLD(a0)
	clr.w	PLANE_YS_OLD(a0)

	; Close archive
	move.w	d6,d0
	bsr	Free

	; Generate Dhz/Hdz buffer...
	move.l	Dhz_A_table(a6),a0
	moveq	#(-3),d0
	bsr	special1_copy_16		; 16
	addq.b	#1,d0
	bsr	special1_copy_16		; 32
	addq.b	#1,d0
	bsr	special1_copy_16		; 48
	addq.b	#1,d0
	bsr	special1_copy_16		; 64
	subq.b	#1,d0
	bsr	special1_copy_16		; 80
	subq.b	#1,d0
	bsr	special1_copy_16		; 96
	subq.b	#1,d0
	bsr	special1_copy_16		; 112
	subq.b	#1,d0
	bsr	special1_copy_16		; 128

	; Generate the Hdz buffer)
	move.l	Hdz_A_table(a6),a0
	moveq	#(SCREEN_Y/32-1),d0
\Hloop:		move.w	#-VIRTUAL_X,(a0)+
		move.w	#-VIRTUAL_X,(a0)+
		move.w	#-VIRTUAL_X,(a0)+
		moveq	#(13-1),d1
\lp:			clr.w	(a0)+
			dbf	d1,\lp
		move.w	#VIRTUAL_X,(a0)+
		move.w	#VIRTUAL_X,(a0)+
		move.w	#VIRTUAL_X,(a0)+
		moveq	#(13-1),d1
\lp2:			clr.w	(a0)+
			dbf	d1,\lp2
		dbf	d0,\Hloop


	; Boucle principale
\loop
	; Attente synchro
	clr.l	genlib::timer
	tst.l	genlib::timer
	beq.s	\loop

	move.l	Plan_A_adr(a6),a0
	move.l	Dhz_A_table(a6),a4
	move.l	Hdz_A_table(a6),a5
	jsr	genlib::put_dhz_plane

	move.l	Plan_B_adr(a6),a0
	jsr	genlib::put_fgrd_plane

	bsr	Wait_next_frame

	; Update the dhz table : rotation
	move.l	Dhz_A_table(a6),a0
	lea	1(a0),a1
	move.b	(a0),d3
	moveq	#(SCREEN_Y-2),d1
\loop2:		move.b	(a1)+,(a0)+
		dbf	d1,\loop2
	move.b	d3,(a0)

	; Update the Hdz table
	move.l	Hdz_A_table(a6),a0
	lea	2(a0),a1
	move.w	(a0),d3
	moveq	#(SCREEN_Y-2),d1
\loop3:		move.w	(a1)+,(a0)+
		dbf	d1,\loop3
	move.w	d3,(a0)

	jsr	genlib::keypressed
	tst.w	d0
	beq	\loop

intro_quit:
	rts

special1_copy_16:
	moveq	#15,d1
\lopp:	move.b	d0,(a0)+
	dbf	d1,\lopp
	rts

Data_shk	incbin "demos\intro.shk"

	EVEN
