
	IFD ti89
YScreen	EQU		100
X_Def		EQU		80
Y_Def		EQU		50
Limite_X	EQU		152
Limite_Y	EQU		92
MaxZoom		EQU		150
	ENDIF

	IFND ti89
YScreen	EQU		128
X_Def		EQU		120
Y_Def		EQU		64
Limite_X	EQU		232
Limite_Y	EQU		120
MaxZoom		EQU		200
	ENDIF

XScreen		EQU		30
Traj_Modif	EQU		50
BallTableSize	EQU		10
TDuration	EQU		200
StartZoom	EQU		1
ProgZoom	EQU		1
AccelZoom	EQU		4
WaitBall	EQU		5
AddDecaBall	EQU		20


	; ***** VMem2Screen *****

	; Entre : Aucune
	; Sortie : Aucune
	; Modifi : Aucun

VMem2Screen:
	movem.l	d0-d1/a0-a3,-(a7)
	moveq	#(8*XScreen)/4-1,d0
	move.l	Screen_2(a6),a0			; Adresse des crans virtuels
	lea	SCREEN_SIZE(a0),a1
	lea	(YScreen-8)*XScreen(a0),a2
	lea	(YScreen-8)*XScreen(a1),a3
	moveq	#-1,d1
\LOOP_BORDURE	move.l	d1,(a0)+
		clr.l	(a1)+
		move.l	d1,(a2)+
		clr.l	(a3)+
		dbra	d0,\LOOP_BORDURE
		
	move.w	#(YScreen*XScreen)/4-1,d0
	move.l	Screen_2(a6),a0			; Adresse des crans virtuels
	lea	SCREEN_SIZE(a0),a1
	move.l	Screen_1(a6),a2			; Adresse des rans
	lea	SCREEN_SIZE(a2),a3
\LOOP_CLS	move.l		(a0)+,(a3)+			; Copie ecran1
		move.l		(a1)+,(a2)+			; Copie ecran2
		dbra		d0,\LOOP_CLS
	movem.l	(a7)+,d0-d1/a0-a3
	rts



	; ***** InitTunnel *****

	; Fonction indpendante
	; Aucune modification des registres

InitTunnel:
	clr.w	TunnelTime
	clr.w	TbefNew
	clr.b	Quit
	lea	BallTable(Pc),a0
	moveq	#(BallTableSize*2)-1,d0
\LOOP_INITTUNNEL
		clr.b		(a0)+
		dbra		d0,\LOOP_INITTUNNEL
	rts
	
	
	
	; ***** PutSprite *****

	; Entre :	D6 = X
	;		D7 = Y
	; Sortie :	Aucune
	; Modifi :	D6-D7

PutSprite:
	movem.l	a0-a2/d3-d5,-(a7)

	move.l	Screen_2(a6),a0			; Adresse des crans
	move.w	d6,d4
	lsr.w	#4,d6				; X Div 16
	add.w	d6,d6
	and.w	#15,d4				; X Mod 16

	add.w	d7,d7
	move.w	d7,d5
	lsl.w	#4,d7
	sub.w	d5,d7				; Y Mul 30

	add.w	d6,d7

	adda.w	d7,a0				; Ecrans positionns

	move.w	Zoom(pc),d3			; Sprite selon le zoom
	cmp.b	#20,d3
	bls.s	\Sprite1
		cmp.b	#40,d3
		bls.s	\Sprite2
			cmp.b	#80,d3
			bls.s	\Sprite3
				clr.w	d3
				bra.s	\SelectZoom
\Sprite1
	lea	90(a0),a0
	moveq	#3*2,d3
	bra.s	\SelectZoom

\Sprite2
	lea	60(a0),a0
	moveq	#2*2,d3
	bra.s	\SelectZoom

\Sprite3
	lea	30(a0),a0
	moveq	#1*2,d3
\SelectZoom
	lea	SCREEN_SIZE(a0),a1		; a1 -> Second ecran

	moveq	#16,d6				; Optimisation dcalage
	sub.w	d4,d6

	move.w	Spr2_table(Pc,d3.w),d3
	lea	Spr2_table(Pc,d3.w),a2	; Pointeur sur sprite

	move.w	(a2)+,d3			; Rcupration taille Y-1 du sprite
\LOOP_PUTSPRITE
		moveq	#0,d4
		move.b	(a2)+,d4			; Rcupration donnes ecran1 (LR)
		lsl.l	d6,d4
		moveq	#0,d5
		move.b	(a2)+,d5			; Rcupration donnes ecran2 (LR)
		lsl.l	d6,d5
		move.l	d4,d7
		or.l	d5,d7
		not.l	d7
		and.l	d7,(a0)			; Affichage du masque (R)
		and.l	d7,(a1)
		or.l	d4,(a0)
		or.l	d5,(a1)
		lea	30(a0),a0
		lea	30(a1),a1				; Ligne suivante
		dbra		d3,\LOOP_PUTSPRITE
	movem.l	(a7)+,a0-a2/d3-d5
	rts

Spr2_table:
	dc.w	sprite1-Spr2_table
	dc.w	sprite2-Spr2_table
	dc.w	sprite3-Spr2_table
	dc.w	sprite4-Spr2_table





	; ***** CalcXY *****

	; Entre :	D6 = X
	;		D7 = Y
	; Sortie :	D6 = X zoom
	;		D7 = Y zoom
	; Modifi :	D6-D7

CalcXY:
	move.w	Zoom(pc),d4
	moveq	#Traj_Modif,d5
	mulu.w	d4,d5
	lsr.w	#6,d5
	mulu.w	d4,d6
	lsr.w	#6,d6
	mulu.w	d4,d7
	lsr.w	#6,d7
	add.b	#X_Def,d6
	sub.b	d5,d6
	add.b	#Y_Def,d7
	sub.b	d5,d7
	cmp.w	#Limite_X,d6
	bhi.s	\Limite_DT
		cmp.w	#Limite_Y,d7
		bls.s	\Done
\Limite_DT		move.w	#Limite_X,d6
			moveq	#Limite_Y,d7
\Done:	rts






	; ***** PlaceBallCircle *****

	; Fonction indpendante
	; Aucune modification des registres

PlaceBallCircle:
	movem.l	d0-d7/a0-a6,-(a7)
	lea	time_traj(pc),a0
	move.w	(a0)+,d0
	lsr.w	#3,d0
	move.w	DecaBall(pc),d1
	and.w	#7,d1			; Cration du dcalage
	lsl.w	#1,d1
	adda.w	d1,a0
	subq.b	#1,d0
LOOP_PLACEBALLCIRCLE:
		clr.w	d6
		move.b	(a0)+,d6
		clr.w	d7
		move.b	(a0),d7
		bsr.s	CalcXY
		bsr	PutSprite
		lea	15(a0),a0
		dbra	d0,LOOP_PLACEBALLCIRCLE
	movem.l	(a7)+,d0-d7/a0-a6
	rts





	; ***** UseBallTable *****

	; Fonction indpendante
	; Aucune modification des registres

DrawBallTable:
	movem.l	d0-d1/a0,-(a7)
	lea	BallTable(pc),a0
	moveq	#BallTableSize-1,d1
\LOOP_DRAWBALLTABLE
		clr.w	d0
		move.b	(a0)+,d0
		beq.s	\EmptySpaceBall
			move.w	d0,Zoom
			clr.w	d0
			move.b	(a0)+,d0
			lsr.b	#5,d0
			move.w	d0,DecaBall
			bsr.s	PlaceBallCircle		; Affichage du cercle de balles
		dbra	d1,\LOOP_DRAWBALLTABLE
	movem.l	(a7)+,d0-d1/a0
	rts

\EmptySpaceBall
		addq.l	#1,a0
		dbra	d1,\LOOP_DRAWBALLTABLE
	movem.l	(a7)+,d0-d1/a0
	rts




	; ***** UpdateBallTable *****

	; Fonction indpendante
	; Aucune modification des registres
	; REM : Le tableau fonctionne come une pile FIFO

UpdateBallTable:
	movem.l	d0-d4/a0-a1,-(a7)
	lea	BallTable(pc),a0
	moveq	#BallTableSize-1,d0
\LOOP_UPDATEBALLTABLE
		move.b	(a0),d1
		move.b	1(a0),d2
		cmp.b	#MaxZoom,d1		; Effacer un cercle trop grand
		bhi	\Clear_Place
			tst.b	d1
			beq.s	\No_Update
				add.w	#ProgZoom,d1		; Mise  jour des infos du cercle
				move.b	d1,d3
				lsr.b	#AccelZoom,d3
				add.w	d3,d1			; Acclration du zoom
				move.b	d1,(a0)+
				add.w	#AddDecaBall,d2
				move.b	d2,(a0)+
				bra.s	\Go_Loop
\No_Update		addq.l	#2,a0
			bra	\Go_Loop
\Clear_Place
		clr.b	(a0)+
		clr.b	(a0)+
\Go_Loop	dbra	d0,\LOOP_UPDATEBALLTABLE

	move.w	TunnelTime(pc),d3
	cmp.w	#TDuration,d3
	bls.s	\NoTimeUp
		lea	BallTable(pc),a0
		tst.b	(a0)
		bne.s	\NoNewBall
			move.b	#1,Quit
			bra.s	\NoNewBall
\NoTimeUp
	addq.w	#1,d3
	move.w	d3,TunnelTime
	move.w	TbefNew(pc),d3
	bne.s	\NoNewBall
		move.l	a0,a1
		clr.b	-(a0)
		clr.b	-(a0)
		moveq	#BallTableSize-2,d4
\LOOP_DECALBALLTABLE
			move.b	-(a0),-(a1)
			move.b	-(a0),-(a1)
			dbra		d4,\LOOP_DECALBALLTABLE
		move.b	#StartZoom,(a0)+
		clr.b	(a0)+
		moveq	#WaitBall+1,d3
\NoNewBall
	subq.w	#1,d3
	move.w	d3,TbefNew
	movem.l	(a7)+,d0-d4/a0-a1
	rts




	; ***** WaveTextGen *****

	; Fonction indpendante
	; Aucune modification des registres

WaveTextGen:
	movem.l	d0-d4/a0-a1,-(a7)
	lea	Wavetext(Pc),a0
	lea	32*8(a0),a1
	moveq	#63,d0
\LOOP_WAVETEXTGEN				; Copie de la texture
		move.l	(a0)+,(a1)+
		dbra	d0,\LOOP_WAVETEXTGEN

	lea	Wavedec(pc),a1
	moveq	#32,d3
	clr.w	d1
	move.b	DecaTW(pc),d1
	addq.w	#1,d1
	divu	#32,d1
	swap	d1
	adda.w	d1,a1
	sub.w	d1,d3
	move.b	d1,DecaTW
	moveq	#31,d0
\LOOP_WAVEDEC
		move.b	(a1)+,d2
		move.l	(a0),d4
		rol.l	d2,d4
		move.l	d4,(a0)+
		move.l	(a0),d4
		rol.l	d2,d4
		move.l	d4,(a0)+
		subq.w	#1,d3
		beq.s	\reset_LOOP_WAVEDEC
		dbra	d0,\LOOP_WAVEDEC
	movem.l	(a7)+,d0-d4/a0-a1
	rts	

\reset_LOOP_WAVEDEC
		lea	Wavedec(Pc),a1
		dbra	d0,\LOOP_WAVEDEC
	movem.l	(a7)+,d0-d4/a0-a1
	rts	





	; ***** AppliWaveText *****

	; Fonction indpendante
	; Aucune modification des registres

AppliWaveText:
	movem.l	d0-d2/a0-a2,-(a7)
	move.l	Screen_2(a6),a1			; Adresse des rans
	lea	SCREEN_SIZE(a1),a2
	moveq	#3,d2
\LOOP_TEXTSCREEN
		lea	Wavetext(Pc),a0
		lea	32*8(a0),a0
		moveq	#31,d1
\LOOP_TEXTMOS
			moveq	#6,d0
\LOOP_TEXTLINE
				move.w	(a0),(a1)+
				move.w	4(a0),(a2)+
				move.w	2(a0),(a1)+
				move.w	6(a0),(a2)+
				dbra	d0,\LOOP_TEXTLINE
			move.w	(a0),(a1)+
			move.w	4(a0),(a2)+
			addq.l	#8,a0
			dbra	d1,\LOOP_TEXTMOS
		dbra	d2,\LOOP_TEXTSCREEN
	movem.l	(a7)+,d0-d2/a0-a2
	rts




	; ***** Dbut du programme *****

demos::timedemo:
	move.l	Screen_1(a6),d0
	jsr	genlib::set_dscreen_int

	bsr		InitTunnel
LOOP_MAIN:
	bsr		WaveTextGen
	bsr		AppliWaveText
	bsr		UpdateBallTable		; Dmarrage du tunnel de balles
	bsr		DrawBallTable			; Affichage des cercles de balles
	bsr		VMem2Screen			; Affichage cran virtuel
	move.b		Quit(pc),d0
	beq		LOOP_MAIN
	rts


;******************** Program Variables ***********************

Zoom		dc.w		0	; Facteur 1 = 64
DecaBall	dc.w		0	; Dcalage de 0  7
SaveHandle	dc.w		0
VScreen1	dc.l		0
TunnelTime	dc.w		0	; Dure rel du tunnel
TbefNew		dc.w		0
Quit		dc.b		0
DecaTW		dc.b		0

BallTable:
	dc.b	0,0			; Zoom + decalage
	ds.b	(BallTableSize-1)*2	; Cercles simultans

Number:
	ds.b		6


Wavetext:
	include		"demos\wavetext.gfx"
	ds.l		32*2
Wavedec:
	dc.b		0,0,0,1,1,1,2,2,3,4,4,5,5,5,6,6,6,6,6,5,5,5,4,4,3,2,2,1,1,1,0,0

time_traj:
	include		"demos\traj2.trj"

sprite1:
	dc.w	7			;YSprite Size
	dc.b	%00100000		;(plane 0, line 0)
	dc.b	%00111100		;(plane 1, line 0)
	dc.b	%01001110		;(plane 0, line 1)
	dc.b	%01110000		;(plane 1, line 1)
	dc.b	%10011111		;(plane 0, line 2)
	dc.b	%11100000		;(plane 1, line 2)
	dc.b	%10111110		;(plane 0, line 3)
	dc.b	%11000001		;(plane 1, line 3)
	dc.b	%10111110		;(plane 0, line 4)
	dc.b	%11000001		;(plane 1, line 4)
	dc.b	%10011100		;(plane 0, line 5)
	dc.b	%11100011		;(plane 1, line 5)
	dc.b	%01000010		;(plane 0, line 6)
	dc.b	%01111110		;(plane 1, line 6)
	dc.b	%00111100		;(plane 0, line 7)
	dc.b	%00111100		;(plane 1, line 7)

sprite2:
	dc.w	5			;YSprite Size
	dc.b	%00100100		;(plane 0, line 0)
	dc.b	%00111000		;(plane 1, line 0)
	dc.b	%01101110		;(plane 0, line 1)
	dc.b	%01110000		;(plane 1, line 1)
	dc.b	%01011110		;(plane 0, line 2)
	dc.b	%01100000		;(plane 1, line 2)
	dc.b	%01001100		;(plane 0, line 3)
	dc.b	%01110010		;(plane 1, line 3)
	dc.b	%01100000		;(plane 0, line 4)
	dc.b	%01111110		;(plane 1, line 4)
	dc.b	%00111100		;(plane 0, line 5)
	dc.b	%00111100		;(plane 1, line 5)

sprite3:
	dc.w	3			;YSprite Size
	dc.b	%00001000		;(plane 0, line 0)
	dc.b	%00010000		;(plane 1, line 0)
	dc.b	%00101100		;(plane 0, line 1)
	dc.b	%00110000		;(plane 1, line 1)
	dc.b	%00100000		;(plane 0, line 2)
	dc.b	%00111100		;(plane 1, line 2)
	dc.b	%00011000		;(plane 0, line 3)
	dc.b	%00011000		;(plane 1, line 3)

sprite4:
	dc.w	1			;YSprite Size
	dc.b	%00001000		;(plane 0, line 0)
	dc.b	%00010000		;(plane 1, line 0)
	dc.b	%00010000		;(plane 0, line 1)
	dc.b	%00011000		;(plane 1, line 1)


	EVEN
