; Some usefull macros...


WriteStr	 MACRO	; X, Y, COL, STR
	move.w	\3,-(a7)
	pea     \4(PC)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr     tios::DrawStrXY
	lea     10(a7),a7
		 ENDM

WriteChar  MACRO	; X, Y, COL, CHAR
	move.b  \4,\@Little_Buffer
	WriteStr \1,\2,\3,\@Little_Buffer
	bra.s	\@helloskip
\@Little_Buffer:
	dc.b 0,0
\@helloskip:
	 ENDM

SetFont 	 MACRO	; FONT
	ifeq	\1
	clr.w	-(a7)		; It is equal to zero so we optimize it !
	jsr	tios::FontSetSys
	addq.l	#2,a7
	endif
	ifne	\1
	move.w	#\1,-(a7)
	jsr tios::FontSetSys
	addq.l	#2,a7
	endif
		 ENDM

Abs	MACRO
	tst.w	\1
	bge.s	\@OkAbs
	neg.w	\1
\@OkAbs:
	ENDM

; Send data debug information
sd	macro
	ifne	DEBUG
	move.w	#\1,$40000
	endif
	endm

sd2	macro
	ifne	DEBUG
	move.w	\1,$40002
	endif
	endm

sd3	macro
	ifne	DEBUG
	move.w	\1,$40004
	endif
	endm

sd4	macro
	ifne	DEBUG
	move.w	\1,$40006
	endif
	endm

sdl	macro
	ifne	DEBUG
	move.l	\1,$40004
	endif
	endm

out	MACRO
	ifne	DEBUG
	move.b	\1,$60000F
	endif
	ENDM

; By Mathieu Lacage

; Call :
; repeat 15,<nom_macro>

;Repeat   macro                      ;
; \2                                 ;
;rcount set \1-1                     ; loop unrolling macro 
; ifne rcount                        ; 
;     Repeat rcount,<\2>             ;
; endif                              ;
;         endm                       ;


smallfont  equ 0
mediumfont equ 1
bigfont    equ 2

NORMAL	EQU	1
GRAS	EQU	2
PETIT	EQU	0

F1	EQU	268
F2	EQU	269
F3	EQU	270
F4	EQU	271
F5	EQU	272
F6	EQU	273
F7	EQU	274
F8	EQU	275

