; ***********************************************************************
; *									*
; *				Story code list				*
; *									*
; ***********************************************************************

	ifnd	FunctionDerefTag

FunctionDerefTag	equ	1

; Les fonctions internes appellables par le script...
member\new		equ	0
member\add		equ	1
member\exchange		equ	2
member\remove		equ	3
member\center		equ	4
member\next		equ	5
member\save_group	equ	6
member\is		equ	7
game\save		equ	8
game\load		equ	9
sprite\push		equ	10
sprite\pop		equ	11
sprite\generate		equ	12
sprite\calculate	equ	13
sprite\reset		equ	14
member\basc		equ	15
demos\t3		equ	16
demos\cf		equ	17
demos\timedemo		equ	18

	endif

	ifnd	ScrptEquTag

ScrptEquTag	equ	1

; Les 16 registres de donnes + le registre de pointeur
r0		equ	0
r1		equ	1
r2		equ	2
r3		equ	3
r4		equ	4
r5		equ	5
r6		equ	6
r7		equ	7
r8		equ	8
r9		equ	9
r10		equ	10
r11		equ	11
r12		equ	12
r13		equ	13
r14		equ	14
r15		equ	15

ptr		equ	0

; Les 8 registres flottants
f0		equ	0
f1		equ	1
f2		equ	2
f3		equ	3
f4		equ	4
f5		equ	5
f6		equ	6
f7		equ	7

; Description du code executable

; Arrete l'histoire
fin	macro
	dc.b	00
	endm

mov	macro
	dc.b	01
	dc.b	\1*16+\2
	endm

movi	macro
	dc.b	02
	dc.w	\1
	dc.b	\2
	endm

load	macro
	dc.b	03
\@lbl	dc.w	\1-\@lbl
	endm

read	macro
	dc.b	04
	dc.b	\1*16+\2
	endm

write	macro
	dc.b	05
	dc.b	\1*16+\2
	endm

addr	macro
	dc.b	06
	dc.b	\1*16+\2
	endm

addri	macro
	dc.b	07
	dc.w	\1
	dc.b	\2
	endm

subr	macro
	dc.b	08
	dc.b	\1*16+\2
	endm

subri	macro
	dc.b	09
	dc.w	\1
	dc.b	\2
	endm


andr	macro
	dc.b	10
	dc.b	\1*16+\2
	endm

andri	macro
	dc.b	11
	dc.w	\1
	dc.b	\2
	endm

orr	macro
	dc.b	12
	dc.b	\1*16+\2
	endm

orri	macro
	dc.b	13
	dc.w	\1
	dc.b	\2
	endm

xor	macro
	dc.b	14
	dc.b	\1*16+\2
	endm

xori	macro
	dc.b	15
	dc.w	\1
	dc.b	\2
	endm

je	macro
	dc.b	16
\@lbl	dc.w	\1-\@lbl
	endm

jne	macro
	dc.b	17
\@lbl	dc.w	\1-\@lbl
	endm

jump	macro
	dc.b	18
\@lbl	dc.w	\1-\@lbl
	endm

call	macro
	dc.b	19
\@lbl	dc.w	\1-\@lbl
	endm

ret	macro
	dc.b	20	
	endm

testobj	macro
	dc.b	21
	dc.w	\1
	endm

teststo	macro
	dc.b	22
	dc.w	\1
	endm

newp	macro
	dc.b	23
	dc.b	\1			; Type.b
	dc.w	\2			; Perso.w
	dc.b	\3			; Level.b
\@lbl	dc.w	\4-\@lbl
	dc.b	\5*16+\6		; Position (var)
	endm

news	macro
	dc.b	24
	dc.w	\1			; Sprite.w
	dc.b	\2*16+\3		; Position (var)
	endm

movpvar	macro
	dc.b	25
	dc.b	\1*16+\2		; Var1 = Perso.w /  Var2 = Nbr
	dc.b	\3*16+\4		; Var3 = X / Var4 = Y 
	endm

movpxy	macro
	dc.b	26
	dc.w	\1			; Perso.w
	dc.b	\2			; Nbr.b
	dc.b	\3			; Dx
	dc.b	\4			; Dy
	endm

movppos	macro
	dc.b	27
	dc.w	\1			; Perso.w
	dc.b	\2			; Nbr.b
	dc.w	\3			; Numero de Position 
	endm

setani	macro
	dc.b	28
	dc.w	\1			; Perso.w
	dc.b	\2			; Nbr.b
	dc.b	\3			; Ani.b
	dc.b	\4			; Sens.b
	endm

wait	macro
	dc.b	29
	dc.b	\1
	endm

display	macro
	dc.b	30
	endm

loadmap	macro
	dc.b	31			; A la ligne !
	endm

dialog	macro
	dc.b	32			; A la ligne !
	endm

remove	macro
	dc.b	33
	dc.w	\1			; Perso.w
	dc.b	\2			; Nbr.b
	endm

giveobj	macro
	dc.b	34
	dc.w	\1			; Object.w
	endm

givesto	macro
	dc.b	35
	dc.w	\1			; Story.w
	endm

getkey	macro
	dc.b	36
	dc.b	\1
	endm

setdiag	macro
	dc.b	37
	dc.w	\1			; Perso.w
	dc.b	\2			; Nbr.b
\@lbl	dc.w	\3-\@lbl
	endm

scroll	macro
	dc.b	39
	dc.b	\1*16+\2
	endm

getxy	macro
	dc.b	40
	dc.w	\1			; Perso.w
	dc.b	\2			; Nbr.b
	dc.b	\3*16+\4		; Var3 = X / Var4 = Y 
	endm

derefp	macro
	dc.b	41
	dc.w	\1			; Position.w
	dc.b	\2*16+\3		; Var1 = X / Var2 = Y
	endm

view	macro
	dc.b	42
	dc.b	\1*16+\2		; Var1 = Perso / Var2 = Nbr
	dc.b	\3*16+\4		; Var3 = Perso / Var4 = Nbr
	endm

readp	macro
	dc.b	43
	dc.b	\1*16+\2
	endm

writep	macro
	dc.b	44
	dc.b	\1*16+\2
	endm

readm	macro
	dc.b	45
	dc.b	\1*16+\2
	endm

writem	macro
	dc.b	46
	dc.b	\1*16+\2
	endm

putspr	macro
	dc.b	47
	dc.b	\1*16+\2
\@lbl	dc.w	\3-\@lbl
	endm

dline	macro
	dc.b	48
	dc.b	\1*16+\2	; x1,y1
	dc.b	\3*16+\4	; x2,y2
	dc.b	\5		; color
	endm

dcircle	macro
	dc.b	49
	dc.b	\1*16+\2	; x,y
	dc.b	\3*16+\4	; r,color
	endm

dtriangle	macro
	dc.b	50
	dc.b	\1*16+\2	; Point1,Point2
	dc.b	\3*16+\4	; Point3,Color
	endm

call68k	macro
	dc.b	51
\@lbl	dc.w	\1-\@lbl
	endm

func	macro
	dc.b	52
	dc.w	\1
	dc.w	\2
	endm

cmpr	macro
	dc.b	53
	dc.b	\1*16+\2
	endm

cmpri	macro
	dc.b	54
	dc.w	\1
	dc.b	\2
	endm


newscript	macro
	dc.b	55
\@lbl	dc.w	\1-\@lbl
	endm

readkey	macro
	dc.b	56
	dc.b	\1	; Var.
	endm

newtype	macro
	dc.b	57
	dc.b	\1,\2	; OldType.b / NewType.b
	endm

exeption	macro
	dc.b	58
\@lbl	dc.w	\1-\@lbl
	endm

blockR	macro
	dc.b	59
	dc.b	\1*16+\2	; Var x.W / Var y.w
	dc.b	\3		; Where to read ?
	endm
	
blockW	macro
	dc.b	60
	dc.b	\1*16+\2	; Var x.w / Var y.w
	dc.b	\3		; Where to write
	endm

graphR	macro
	dc.b	61
	dc.b	\1*16+\2
	dc.b	\3	
	endm
	
graphW	macro
	dc.b	62
	dc.b	\1*16+\2
	dc.b	\3
	endm

itemR	macro
	dc.b	63
	dc.b	\1*16+\2
	dc.b	\3	
	endm
	
itemW	macro
	dc.b	64
	dc.b	\1*16+\2
	dc.b	\3
	endm

savemode	macro
	dc.b	65
	endm

loadmode	macro
	dc.b	66
	endm

loadpb	macro
	dc.b	67
	dc.b	\1,\2	; SizeX / SizeY
\@lbl	dc.w	\3-\@lbl
\@lbl2	dc.w	\4-\@lbl2
	endm

scrollpb	macro
	dc.b	68
	dc.b	\1*16+\2	; Var / Var
	endm

setmode	macro
	dc.b	69
	dc.b	\1
	endm

loaddhzpb	macro
	dc.b	70
\@lbl	dc.w	\1-\@lbl
\@lbl2	dc.w	\2-\@lbl2
	endm

loaddhzpa	macro
	dc.b	71
\@lbl	dc.w	\1-\@lbl
\@lbl2	dc.w	\2-\@lbl2
	endm

declum	macro
	dc.b	72
	endm

inclum	macro
	dc.b	73
	endm

fltmovi	macro
	dc.b	74
	dc.l	\1*65536/\2
	dc.b	\3
	endm
fltint	macro
	dc.b	75
	dc.b	\1*16+\2
	endm
fltint2	macro
	dc.b	76
	dc.b	\1*16+\2
	endm
fltadd	macro
	dc.b	77
	dc.b	\1*16+\2
	endm
fltsub	macro
	dc.b	78
	dc.b	\1*16+\2
	endm
fltmul	macro
	dc.b	79
	dc.b	\1*16+\2
	endm
fltdiv	macro
	dc.b	80
	dc.b	\1*16+\2
	endm
fltcos	macro
	dc.b	81
	dc.b	\1*16+\2
	endm
fltsin	macro
	dc.b	82
	dc.b	\1*16+\2
	endm
fltmov	macro
	dc.b	83
	dc.b	\1*16+\2
	endm
fltload	macro
	dc.b	84
\@lbl	dc.w	\1-\@lbl
	dc.b	\2
	endm
fltsave	macro
	dc.b	85
	dc.b	\1
\@lbl	dc.w	\2-\@lbl
	endm

fltcmp	macro
	dc.b	86
	dc.b	\1*16+\2
	endm

fltset	macro
	dc.b	87
	dc.l	\1*65536/\2
	endm

pause	macro
	dc.b	88
	endm

jg	macro
	dc.b	89	
\@lbl	dc.w	\1-\@lbl
	endm

jl	macro
	dc.b	90
\@lbl	dc.w	\1-\@lbl
	endm

; 0 -> Global / 1 -> Relatif !
setcoord	macro
	dc.b	38
	dc.b	\1
	endm

message	MACRO
	dc.b	91
	dc.b	\1,\2
	dc.b	\3,\4,\5,\6
	ENDM


illegal_code	macro
	dc.b	255
	endm

	endif

