; Module sprite
; Sous-module : Sprite contenant un perso qui bouge de facon aleatoire

; On passe en argument :
;	d3.w = No du personnage a initialiser.
;	d4.w = Level du perso ou '0' s'il ne peut pas se battre
;	A4.l -> Dialog struct ou NULL

init_aleatoire:
	move.w	#10,P_cpt(a5)
	clr.w	P_action(a5)
	rts

exec_aleatoire:
	move.l	(a3)+,a5

	; Le faire se deplacer et mettre a jour l'animation et le sens
	subq.w	#1,P_cpt(a5)
	bne.s	\no_new_direction
		eor.w	#1,P_action(a5)		; Change action
		moveq	#50,d0
		bsr	random
		addq.w	#8,d0
		move.w	d0,P_cpt(a5)
		moveq	#4,d0
		bsr	random
		move.b	d0,Sens(a5)
\no_new_direction:
	
	moveq	#ANI_NORMAL,d5
	tst.w	P_action(a5)
	beq.s	\immobile
		move.w	X(a5),d3
		move.w	Y(a5),d4
		move.b	Sens(a5),d2
		tst.b	d2
		bne.s	\no1
			subq.w	#2,d4
\no1:		subq.b	#1,d2
		bne.s	\no2
			addq.w	#2,d4
\no2:		subq.b	#1,d2
		bne.s	\no3
			subq.w	#2,d3
\no3:		subq.b	#1,d2
		bne.s	\no4
			addq.w	#2,d3
\no4:		bsr	player::check_move
		moveq	#ANI_WALK,d5
\immobile:	
	bsr	player::animation

	bra	immobile::collision
