; Fichier "function"

; Liste des fonctions :
;	function::call

; Appelle une fonction particuliere du programme en passant son numero
; Utile pour le codage des fonctions internes dans les scripts.
; Par exemple, dans le event-code, la syntaxe : func member\new
; fait appel a cette fonction en donnant le numero de member\new
; Utile poour avoir a eviter de coder toutes les fonctions...
; In:
;	Function_numero.w pushed on the stack
;	Registers like the function
; Out:
;	Like the called function
; Destroy:
;	Like the called function
function::call:
	move.w	d0,-(a7)
	move.w	4+2(a7),d0
	add.w	d0,d0
	move.w	Func(Pc,d0.w),d0
	pea	\return(Pc)
	pea	Func(Pc,d0.w)
	move.w	(4+4+2)(a7),d0
	rts
\return	addq.w	#2,a7
	rts

Func:
	dc.w	member::new-Func
	dc.w	member::add-Func
	dc.w	member::exchange-Func
	dc.w	member::remove-Func
	dc.w	member::center-Func
	dc.w	member::next-Func
	dc.w	member::save_group-Func
	dc.w	member::is-Func

	dc.w	game::save-Func
	dc.w	game::load-Func

	dc.w	sprite::push-Func
	dc.w	sprite::pop-Func
	dc.w	sprite::generate-Func
	dc.w	sprite::calculate-Func
	dc.w	sprite::reset-Func

	dc.w	member::basc-Func

	dc.w	demos::t3-Func
	dc.w	demos::cf-Func
	dc.w	demos::timedemo-Func
