; Map header file
	NEW_DATA

	rs	Graph_adr,4			; Adress of the graph table (the unarchived gfx map)
	rs	Height_tab,4			; Adress of the height/item table (the unarchived height tab)
	rs	Items_list,4			; Adress of the object-list of the map

	rs	Map_adr,4			; Adress of the compressed map

	rs	Archive_hd,2			; handle of the archived data (shrink)

	rs	Map_x,2				; Map size X = 2^Sx
	rs	Map_y,2				; Map size Y
	rs	Map_size,2			; = 2^Sx * Sy = Nombre d'octets de la map
	rs	Mask_x,2			; Mask =%00000..1111 with (Sx1 -1) of 1


; Touches (Ok, je sais pas dans quel fichier le mettre)
action_key	equ	ka_key
run_key		equ	ke_key
menu_key	equ	kb_key
perso_key	equ	kf_key


; Description d'une carte
	NEW_STRUCT	Carte
	rs	map_gfx_name,8+1		; Nom du fichier gfx (commun aux 2 plans)
	rs	map_print_way,1			; Facon d'afficher
	rs	map_size_x,1			; Sx ou 2^Sx est la vrai taille (Plan 1)
	rs	map_size_y,1			; Sy
	rs	map_size2_x,1			; Sx2 ou 2^Sx2 est la vrai taille (Plan 2)
	rs	map_size2_y,1			; Sy2
	rs	map_compressed,0		; Carte compressee (Taille variable).
	END_STRUCT	map_size		; pas vraiment representatif.
; Dans la carte compressee, on a :
; Fichier 0 : Matrice gfx du plan 1
; Fichier 1 : Matrice gfx du plan 2
; Fichier 2 : Matrice Hauteur / Item
; Fichier 3 : Liste des Items de la carte.

; Description d'un item dans la liste des items
	NEW_STRUCT	Item
	rs	item_type,1			; Type d'item
	rs	item_sprite,1			; No du sprite si item = sprite
	rs	item_no,2			; No du perso / no d''objet / no d'evenement...
	rs	item_level,2			; Level du perso / no de coffre
	rs	item_dialog,2			; offset vers struct de dialogue
	END_STRUCT	item_size

; Quelques numero d'items
ITEM_NOTHING	EQU	0
ITEM_CHEST	EQU	1
ITEM_DIALOG	EQU	2
ITEM_STORY	EQU	3
ITEM_LOC_STORY	EQU	4
ITEM_BLOCK_OBJ	EQU	5
ITEM_BLOCK_STO	EQU	6
ITEM_LADDER	EQU	7
ITEM_FALL	EQU	8
ITEM_MAP	EQU	'a'
